#cython: language_level=3
#cython: binding=False
#cython: boundscheck=False
#cython: wraparound=False
#cython: nonecheck=False
#cython: cdivision=True
#cython: always_allow_keywords=True
#cython: optimize.use_switch=True

cimport cython
from libc.math cimport sqrt


@cython.freelist(4096)
@cython.no_gc
@cython.final
cdef class Vec2:
    cdef public double x, y


    cdef void ___init___0(self) noexcept:
        self.x = self.y = 0.0

    cdef void ___init___1(self, double value) noexcept:
        self.x = self.y = value

    cdef void ___init___2(self, Vec2i vec) noexcept:
        self.x = <double>vec.x
        self.y = <double>vec.y

    cdef void ___init___3(self, Vec2 xy) noexcept:
        self.x = xy.x
        self.y = xy.y
    
    cdef void ___init___4(self, double x, double y) noexcept:
        self.x = x
        self.y = y

    def __init__(self, p0=None, p1=None, /):
        if isinstance(p0, float):
            if isinstance(p1, float):
                self.___init___4(p0, p1)
                return
            elif isinstance(p1, int):
                self.___init___4(p0, p1)
                return
            elif p1 is None:
                self.___init___1(p0)
                return
            else:
                raise TypeError(f"The 3th parameter expected float | int | None, got {p1}")
        elif isinstance(p0, int):
            if isinstance(p1, float):
                self.___init___4(p0, p1)
                return
            elif isinstance(p1, int):
                self.___init___4(p0, p1)
                return
            elif p1 is None:
                self.___init___1(p0)
                return
            else:
                raise TypeError(f"The 3th parameter expected float | int | None, got {p1}")
        elif isinstance(p0, Vec2i):
            if isinstance(p1, float):
                raise TypeError("No matching overload function for parameter types: self, Vec2i, float")
            elif isinstance(p1, int):
                raise TypeError("No matching overload function for parameter types: self, Vec2i, int")
            elif p1 is None:
                self.___init___2(p0)
                return
            else:
                raise TypeError(f"The 3th parameter expected float | int | None, got {p1}")
        elif isinstance(p0, Vec2):
            if isinstance(p1, float):
                raise TypeError("No matching overload function for parameter types: self, Vec2, float")
            elif isinstance(p1, int):
                raise TypeError("No matching overload function for parameter types: self, Vec2, int")
            elif p1 is None:
                self.___init___3(p0)
                return
            else:
                raise TypeError(f"The 3th parameter expected float | int | None, got {p1}")
        elif p0 is None:
            if isinstance(p1, float):
                raise TypeError("No matching overload function for parameter types: self, None, float")
            elif isinstance(p1, int):
                raise TypeError("No matching overload function for parameter types: self, None, int")
            elif p1 is None:
                self.___init___0()
                return
            else:
                raise TypeError(f"The 3th parameter expected float | int | None, got {p1}")
        else:
            raise TypeError(f"The 2th parameter expected float | int | Vec2i | Vec2 | None, got {p0}")


    def __repr__(self):
        return f"Vec2({self.x}, {self.y})"

    def __eq__(self, object other):
        if not isinstance(other, Vec2):
            return False
        return self.x == other.x and self.y == other.y

    def __ne__(self, object other):
        if not isinstance(other, Vec2):
            return True
        return self.x != other.x or self.y != other.y

    def __bool__(self):
        return self.x == 0 and self.y == 0

    def __pos__(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x
        vec.y = self.y
        return vec

    def __neg__(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = -self.x
        vec.y = -self.y
        return vec

    cdef Vec2 ___add___0(self, Vec2 other) noexcept:
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x + other.x
        vec.y = self.y + other.y
        return vec
    
    cdef Vec2 ___add___1(self, double other) noexcept:
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x + other
        vec.y = self.y + other
        return vec
    
    def __add__(self, p0, /):
        if isinstance(p0, Vec2):
            return self.___add___0(p0)
        elif isinstance(p0, float):
            return self.___add___1(p0)
        elif isinstance(p0, int):
            return self.___add___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec2 | float | int, got {p0}")
    
    cdef Vec2 ___iadd___0(self, Vec2 other) noexcept:
        self.x += other.x
        self.y += other.y
        return self
    
    cdef Vec2 ___iadd___1(self, double other) noexcept:
        self.x += other
        self.y += other
        return self
    
    def __iadd__(self, p0, /):
        if isinstance(p0, Vec2):
            return self.___iadd___0(p0)
        elif isinstance(p0, float):
            return self.___iadd___1(p0)
        elif isinstance(p0, int):
            return self.___iadd___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec2 | float | int, got {p0}")

    cdef Vec2 ___sub___0(self, Vec2 other) noexcept:
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x - other.x
        vec.y = self.y - other.y
        return vec
    
    cdef Vec2 ___sub___1(self, double other) noexcept:
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x - other
        vec.y = self.y - other
        return vec
    
    def __sub__(self, p0, /):
        if isinstance(p0, Vec2):
            return self.___sub___0(p0)
        elif isinstance(p0, float):
            return self.___sub___1(p0)
        elif isinstance(p0, int):
            return self.___sub___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec2 | float | int, got {p0}")
    
    cdef Vec2 ___isub___0(self, Vec2 other) noexcept:
        self.x -= other.x
        self.y -= other.y
        return self
    
    cdef Vec2 ___isub___1(self, double other) noexcept:
        self.x -= other
        self.y -= other
        return self
    
    def __isub__(self, p0, /):
        if isinstance(p0, Vec2):
            return self.___isub___0(p0)
        elif isinstance(p0, float):
            return self.___isub___1(p0)
        elif isinstance(p0, int):
            return self.___isub___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec2 | float | int, got {p0}")

    cdef Vec2 ___mul___0(self, Vec2 other) noexcept:
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x * other.x
        vec.y = self.y * other.y
        return vec
    
    cdef Vec2 ___mul___1(self, double other) noexcept:
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x * other
        vec.y = self.y * other
        return vec
    
    def __mul__(self, p0, /):
        if isinstance(p0, Vec2):
            return self.___mul___0(p0)
        elif isinstance(p0, float):
            return self.___mul___1(p0)
        elif isinstance(p0, int):
            return self.___mul___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec2 | float | int, got {p0}")
    
    cdef Vec2 ___imul___0(self, Vec2 other) noexcept:
        self.x *= other.x
        self.y *= other.y
        return self
    
    cdef Vec2 ___imul___1(self, double other) noexcept:
        self.x *= other
        self.y *= other
        return self
    
    def __imul__(self, p0, /):
        if isinstance(p0, Vec2):
            return self.___imul___0(p0)
        elif isinstance(p0, float):
            return self.___imul___1(p0)
        elif isinstance(p0, int):
            return self.___imul___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec2 | float | int, got {p0}")

    cdef Vec2 ___truediv___0(self, Vec2 other) noexcept:
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x / other.x
        vec.y = self.y / other.y
        return vec
    
    cdef Vec2 ___truediv___1(self, double other) noexcept:
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x / other
        vec.y = self.y / other
        return vec
    
    def __truediv__(self, p0, /):
        if isinstance(p0, Vec2):
            return self.___truediv___0(p0)
        elif isinstance(p0, float):
            return self.___truediv___1(p0)
        elif isinstance(p0, int):
            return self.___truediv___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec2 | float | int, got {p0}")
    
    cdef Vec2 ___itruediv___0(self, Vec2 other) noexcept:
        self.x /= other.x
        self.y /= other.y
        return self
    
    cdef Vec2 ___itruediv___1(self, double other) noexcept:
        self.x /= other
        self.y /= other
        return self
    
    def __itruediv__(self, p0, /):
        if isinstance(p0, Vec2):
            return self.___itruediv___0(p0)
        elif isinstance(p0, float):
            return self.___itruediv___1(p0)
        elif isinstance(p0, int):
            return self.___itruediv___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec2 | float | int, got {p0}")

    def __matmul__(self, Vec2 other) -> double:
        """Vector dot product"""
        return self.x * other.x + self.y * other.y


    def __len__(self):
        return 2

    def __getitem__(self, int key) -> double:
        if key == 0:
            return self.x
        elif key == 1:
            return self.y
        else:
            raise KeyError(f"Vec2 index out of range: {key}")

    def __setitem__(self, int key, double value):
        if key == 0:
            self.x = value
        elif key == 1:
            self.y = value
        else:
            raise KeyError(f"Vec2 index out of range: {key}")

    def __iter__(self):
        cdef _Vec2iterator iterator = _Vec2iterator.__new__(_Vec2iterator)
        iterator.x = self.x
        iterator.y = self.y
        # iterator.vec = self
        return iterator


    @property
    def length(self) -> float:
        return sqrt(self.x * self.x + self.y * self.y)

    @property
    def length_sqr(self) -> float:
        return self.x * self.x + self.y * self.y

    def __or__(self, other: Vec2) -> float:
        """Equivalent to distance_to()"""
        cdef double dx = self.x - other.x
        cdef double dy = self.y - other.y
        return sqrt(<double> (dx * dx + dy * dy))

    def distance_to(self, other: Vec2) -> float:
        cdef double dx = self.x - other.x
        cdef double dy = self.y - other.y
        return sqrt(<double> (dx * dx + dy * dy))

    def distance_sqr_to(self, other: Vec2) -> float:
        cdef double dx = self.x - other.x
        cdef double dy = self.y - other.y
        return <double> (dx * dx + dy * dy)

    @property
    def normalized(self) -> Vec2:
        cdef double l = sqrt(self.x * self.x + self.y * self.y)
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x / l
        vec.y = self.y / l
        return vec


    @property
    def xx(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x
        vec.y = self.x
        return vec
    
    @property
    def xy(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x
        vec.y = self.y
        return vec
    
    @xy.setter
    def xy(self, Vec2 vec):
        self.x = vec.x
        self.y = vec.y
    
    @property
    def xo(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x
        vec.y = 0.0
        return vec
    
    @property
    def xl(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x
        vec.y = 1.0
        return vec
    
    @property
    def yx(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.y
        vec.y = self.x
        return vec
    
    @yx.setter
    def yx(self, Vec2 vec):
        self.y = vec.x
        self.x = vec.y
    
    @property
    def yy(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.y
        vec.y = self.y
        return vec
    
    @property
    def yo(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.y
        vec.y = 0.0
        return vec
    
    @property
    def yl(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.y
        vec.y = 1.0
        return vec
    
    @property
    def ox(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = 0.0
        vec.y = self.x
        return vec
    
    @property
    def oy(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = 0.0
        vec.y = self.y
        return vec
    
    @property
    def lx(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = 1.0
        vec.y = self.x
        return vec
    
    @property
    def ly(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = 1.0
        vec.y = self.y
        return vec
    
    @property
    def xxx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def xxy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def xxo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0.0
        return vec
    
    @property
    def xxl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1.0
        return vec
    
    @property
    def xyx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def xyy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def xyo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0.0
        return vec
    
    @property
    def xyl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1.0
        return vec
    
    @property
    def xox(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.x
        return vec
    
    @property
    def xoy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.y
        return vec
    
    @property
    def xoo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 0.0
        return vec
    
    @property
    def xol(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 1.0
        return vec
    
    @property
    def xlx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.x
        return vec
    
    @property
    def xly(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.y
        return vec
    
    @property
    def xlo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 0.0
        return vec
    
    @property
    def xll(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 1.0
        return vec
    
    @property
    def yxx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def yxy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def yxo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0.0
        return vec
    
    @property
    def yxl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1.0
        return vec
    
    @property
    def yyx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def yyy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def yyo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0.0
        return vec
    
    @property
    def yyl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1.0
        return vec
    
    @property
    def yox(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.x
        return vec
    
    @property
    def yoy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.y
        return vec
    
    @property
    def yoo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 0.0
        return vec
    
    @property
    def yol(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 1.0
        return vec
    
    @property
    def ylx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.x
        return vec
    
    @property
    def yly(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.y
        return vec
    
    @property
    def ylo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 0.0
        return vec
    
    @property
    def yll(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 1.0
        return vec
    
    @property
    def oxx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def oxy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def oxo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 0.0
        return vec
    
    @property
    def oxl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 1.0
        return vec
    
    @property
    def oyx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def oyy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def oyo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 0.0
        return vec
    
    @property
    def oyl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 1.0
        return vec
    
    @property
    def oox(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.x
        return vec
    
    @property
    def ooy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.y
        return vec
    
    @property
    def olx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.x
        return vec
    
    @property
    def oly(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.y
        return vec
    
    @property
    def lxx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def lxy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def lxo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 0.0
        return vec
    
    @property
    def lxl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 1.0
        return vec
    
    @property
    def lyx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def lyy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def lyo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 0.0
        return vec
    
    @property
    def lyl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 1.0
        return vec
    
    @property
    def lox(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.x
        return vec
    
    @property
    def loy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.y
        return vec
    
    @property
    def llx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.x
        return vec
    
    @property
    def lly(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.y
        return vec
    
    @property
    def xxxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xxxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xxxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def xxxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def xxyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xxyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xxyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def xxyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def xxox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def xxoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def xxoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def xxol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def xxlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def xxly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def xxlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def xxll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def xyxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xyxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xyxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def xyxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def xyyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xyyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xyyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def xyyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def xyox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def xyoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def xyoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def xyol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def xylx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def xyly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def xylo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def xyll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def xoxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xoxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xoxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def xoxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def xoyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xoyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xoyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def xoyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def xoox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def xooy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def xooo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def xool(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def xolx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def xoly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def xolo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def xoll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def xlxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xlxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xlxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def xlxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def xlyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xlyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xlyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def xlyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def xlox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def xloy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def xloo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def xlol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def xllx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def xlly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def xllo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def xlll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def yxxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yxxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yxxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def yxxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def yxyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yxyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yxyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def yxyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def yxox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def yxoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def yxoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def yxol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def yxlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def yxly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def yxlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def yxll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def yyxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yyxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yyxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def yyxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def yyyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yyyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yyyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def yyyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def yyox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def yyoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def yyoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def yyol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def yylx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def yyly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def yylo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def yyll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def yoxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yoxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yoxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def yoxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def yoyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yoyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yoyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def yoyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def yoox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def yooy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def yooo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def yool(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def yolx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def yoly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def yolo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def yoll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def ylxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def ylxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def ylxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def ylxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def ylyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def ylyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def ylyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def ylyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def ylox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def yloy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def yloo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def ylol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def yllx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def ylly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def yllo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def ylll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def oxxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def oxxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def oxxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def oxxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def oxyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def oxyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def oxyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def oxyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def oxox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def oxoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def oxoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def oxol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def oxlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def oxly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def oxlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def oxll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def oyxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def oyxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def oyxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def oyxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def oyyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def oyyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def oyyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def oyyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def oyox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def oyoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def oyoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def oyol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def oylx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def oyly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def oylo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def oyll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def ooxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def ooxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def ooxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def ooxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def ooyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def ooyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def ooyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def ooyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def ooox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def oooy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def oolx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def ooly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def olxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def olxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def olxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def olxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def olyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def olyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def olyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def olyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def olox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def oloy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def ollx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def olly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def lxxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def lxxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def lxxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def lxxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def lxyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def lxyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def lxyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def lxyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def lxox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def lxoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def lxoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def lxol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def lxlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def lxly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def lxlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def lxll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def lyxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def lyxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def lyxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def lyxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def lyyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def lyyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def lyyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def lyyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def lyox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def lyoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def lyoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def lyol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def lylx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def lyly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def lylo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def lyll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def loxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def loxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def loxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def loxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def loyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def loyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def loyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def loyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def loox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def looy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def lolx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def loly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def llxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def llxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def llxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def llxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def llyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def llyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def llyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def llyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def llox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def lloy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def lllx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def llly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.y
        return vec


@cython.no_gc
@cython.final
@cython.freelist(8)
cdef class _Vec2iterator:
    cdef public double x, y
    cdef short index


    def __next__(self):
        if self.index == 0:
            self.index += 1
            return self.x
        elif self.index == 1:
            self.index += 1
            return self.y
        raise StopIteration

    def __iter__(self):
        return self

    def __length_hint__(self):
        return 2


@cython.freelist(4096)
@cython.no_gc
@cython.final
cdef class Vec3:
    cdef public double x, y, z


    cdef void ___init___0(self) noexcept:
        self.x = self.y = self.z = 0.0

    cdef void ___init___1(self, double value) noexcept:
        self.x = self.y = self.z = value

    cdef void ___init___2(self, Vec3i vec) noexcept:
        self.x = <double>vec.x
        self.y = <double>vec.y
        self.z = <double>vec.z

    cdef void ___init___3(self, Vec3 xyz) noexcept:
        self.x = xyz.x
        self.y = xyz.y
        self.z = xyz.z
    
    cdef void ___init___4(self, double x, Vec2 yz) noexcept:
        self.x = x
        self.y = yz.x
        self.z = yz.y
    
    cdef void ___init___5(self, Vec2 xy, double z) noexcept:
        self.x = xy.x
        self.y = xy.y
        self.z = z
    
    cdef void ___init___6(self, double x, double y, double z) noexcept:
        self.x = x
        self.y = y
        self.z = z

    def __init__(self, p0=None, p1=None, p2=None, /):
        if isinstance(p0, float):
            if isinstance(p1, Vec2):
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, float, Vec2, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, float, Vec2, int")
                elif p2 is None:
                    self.___init___4(p0, p1)
                    return
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            elif isinstance(p1, float):
                if isinstance(p2, float):
                    self.___init___6(p0, p1, p2)
                    return
                elif isinstance(p2, int):
                    self.___init___6(p0, p1, p2)
                    return
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, float, float, None")
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, float):
                    self.___init___6(p0, p1, p2)
                    return
                elif isinstance(p2, int):
                    self.___init___6(p0, p1, p2)
                    return
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, float, int, None")
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, float, None, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, float, None, int")
                elif p2 is None:
                    self.___init___1(p0)
                    return
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec2 | float | int | None, got {p1}")
        elif isinstance(p0, int):
            if isinstance(p1, Vec2):
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, int, Vec2, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, int, Vec2, int")
                elif p2 is None:
                    self.___init___4(p0, p1)
                    return
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            elif isinstance(p1, float):
                if isinstance(p2, float):
                    self.___init___6(p0, p1, p2)
                    return
                elif isinstance(p2, int):
                    self.___init___6(p0, p1, p2)
                    return
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, int, float, None")
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, float):
                    self.___init___6(p0, p1, p2)
                    return
                elif isinstance(p2, int):
                    self.___init___6(p0, p1, p2)
                    return
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, int, int, None")
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, int, None, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, int, None, int")
                elif p2 is None:
                    self.___init___1(p0)
                    return
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec2 | float | int | None, got {p1}")
        elif isinstance(p0, Vec3i):
            if isinstance(p1, Vec2):
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, Vec3i, Vec2, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec3i, Vec2, int")
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, Vec3i, Vec2, None")
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            elif isinstance(p1, float):
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, Vec3i, float, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec3i, float, int")
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, Vec3i, float, None")
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, Vec3i, int, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec3i, int, int")
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, Vec3i, int, None")
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, Vec3i, None, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec3i, None, int")
                elif p2 is None:
                    self.___init___2(p0)
                    return
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec2 | float | int | None, got {p1}")
        elif isinstance(p0, Vec3):
            if isinstance(p1, Vec2):
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, Vec3, Vec2, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec3, Vec2, int")
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, Vec3, Vec2, None")
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            elif isinstance(p1, float):
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, Vec3, float, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec3, float, int")
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, Vec3, float, None")
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, Vec3, int, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec3, int, int")
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, Vec3, int, None")
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, Vec3, None, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec3, None, int")
                elif p2 is None:
                    self.___init___3(p0)
                    return
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec2 | float | int | None, got {p1}")
        elif isinstance(p0, Vec2):
            if isinstance(p1, Vec2):
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, Vec2, Vec2, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec2, Vec2, int")
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, Vec2, Vec2, None")
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            elif isinstance(p1, float):
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, Vec2, float, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec2, float, int")
                elif p2 is None:
                    self.___init___5(p0, p1)
                    return
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, Vec2, int, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec2, int, int")
                elif p2 is None:
                    self.___init___5(p0, p1)
                    return
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, Vec2, None, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec2, None, int")
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, Vec2, None, None")
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec2 | float | int | None, got {p1}")
        elif p0 is None:
            if isinstance(p1, Vec2):
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, None, Vec2, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, None, Vec2, int")
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, None, Vec2, None")
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            elif isinstance(p1, float):
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, None, float, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, None, float, int")
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, None, float, None")
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, None, int, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, None, int, int")
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, None, int, None")
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, float):
                    raise TypeError("No matching overload function for parameter types: self, None, None, float")
                elif isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, None, None, int")
                elif p2 is None:
                    self.___init___0()
                    return
                else:
                    raise TypeError(f"The 4th parameter expected float | int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec2 | float | int | None, got {p1}")
        else:
            raise TypeError(f"The 2th parameter expected float | int | Vec3i | Vec3 | Vec2 | None, got {p0}")


    def __repr__(self):
        return f"Vec3({self.x}, {self.y}, {self.z})"

    def __eq__(self, object other):
        if not isinstance(other, Vec3):
            return False
        return self.x == other.x and self.y == other.y and self.z == other.z

    def __ne__(self, object other):
        if not isinstance(other, Vec3):
            return True
        return self.x != other.x or self.y != other.y or self.z != other.z

    def __bool__(self):
        return self.x == 0 and self.y == 0 and self.z == 0

    def __pos__(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        return vec

    def __neg__(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = -self.x
        vec.y = -self.y
        vec.z = -self.z
        return vec

    cdef Vec3 ___add___0(self, Vec3 other) noexcept:
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x + other.x
        vec.y = self.y + other.y
        vec.z = self.z + other.z
        return vec
    
    cdef Vec3 ___add___1(self, double other) noexcept:
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x + other
        vec.y = self.y + other
        vec.z = self.z + other
        return vec
    
    def __add__(self, p0, /):
        if isinstance(p0, Vec3):
            return self.___add___0(p0)
        elif isinstance(p0, float):
            return self.___add___1(p0)
        elif isinstance(p0, int):
            return self.___add___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec3 | float | int, got {p0}")
    
    cdef Vec3 ___iadd___0(self, Vec3 other) noexcept:
        self.x += other.x
        self.y += other.y
        self.z += other.z
        return self
    
    cdef Vec3 ___iadd___1(self, double other) noexcept:
        self.x += other
        self.y += other
        self.z += other
        return self
    
    def __iadd__(self, p0, /):
        if isinstance(p0, Vec3):
            return self.___iadd___0(p0)
        elif isinstance(p0, float):
            return self.___iadd___1(p0)
        elif isinstance(p0, int):
            return self.___iadd___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec3 | float | int, got {p0}")

    cdef Vec3 ___sub___0(self, Vec3 other) noexcept:
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x - other.x
        vec.y = self.y - other.y
        vec.z = self.z - other.z
        return vec
    
    cdef Vec3 ___sub___1(self, double other) noexcept:
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x - other
        vec.y = self.y - other
        vec.z = self.z - other
        return vec
    
    def __sub__(self, p0, /):
        if isinstance(p0, Vec3):
            return self.___sub___0(p0)
        elif isinstance(p0, float):
            return self.___sub___1(p0)
        elif isinstance(p0, int):
            return self.___sub___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec3 | float | int, got {p0}")
    
    cdef Vec3 ___isub___0(self, Vec3 other) noexcept:
        self.x -= other.x
        self.y -= other.y
        self.z -= other.z
        return self
    
    cdef Vec3 ___isub___1(self, double other) noexcept:
        self.x -= other
        self.y -= other
        self.z -= other
        return self
    
    def __isub__(self, p0, /):
        if isinstance(p0, Vec3):
            return self.___isub___0(p0)
        elif isinstance(p0, float):
            return self.___isub___1(p0)
        elif isinstance(p0, int):
            return self.___isub___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec3 | float | int, got {p0}")

    cdef Vec3 ___mul___0(self, Vec3 other) noexcept:
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x * other.x
        vec.y = self.y * other.y
        vec.z = self.z * other.z
        return vec
    
    cdef Vec3 ___mul___1(self, double other) noexcept:
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x * other
        vec.y = self.y * other
        vec.z = self.z * other
        return vec
    
    def __mul__(self, p0, /):
        if isinstance(p0, Vec3):
            return self.___mul___0(p0)
        elif isinstance(p0, float):
            return self.___mul___1(p0)
        elif isinstance(p0, int):
            return self.___mul___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec3 | float | int, got {p0}")
    
    cdef Vec3 ___imul___0(self, Vec3 other) noexcept:
        self.x *= other.x
        self.y *= other.y
        self.z *= other.z
        return self
    
    cdef Vec3 ___imul___1(self, double other) noexcept:
        self.x *= other
        self.y *= other
        self.z *= other
        return self
    
    def __imul__(self, p0, /):
        if isinstance(p0, Vec3):
            return self.___imul___0(p0)
        elif isinstance(p0, float):
            return self.___imul___1(p0)
        elif isinstance(p0, int):
            return self.___imul___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec3 | float | int, got {p0}")

    cdef Vec3 ___truediv___0(self, Vec3 other) noexcept:
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x / other.x
        vec.y = self.y / other.y
        vec.z = self.z / other.z
        return vec
    
    cdef Vec3 ___truediv___1(self, double other) noexcept:
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x / other
        vec.y = self.y / other
        vec.z = self.z / other
        return vec
    
    def __truediv__(self, p0, /):
        if isinstance(p0, Vec3):
            return self.___truediv___0(p0)
        elif isinstance(p0, float):
            return self.___truediv___1(p0)
        elif isinstance(p0, int):
            return self.___truediv___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec3 | float | int, got {p0}")
    
    cdef Vec3 ___itruediv___0(self, Vec3 other) noexcept:
        self.x /= other.x
        self.y /= other.y
        self.z /= other.z
        return self
    
    cdef Vec3 ___itruediv___1(self, double other) noexcept:
        self.x /= other
        self.y /= other
        self.z /= other
        return self
    
    def __itruediv__(self, p0, /):
        if isinstance(p0, Vec3):
            return self.___itruediv___0(p0)
        elif isinstance(p0, float):
            return self.___itruediv___1(p0)
        elif isinstance(p0, int):
            return self.___itruediv___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec3 | float | int, got {p0}")

    def __matmul__(self, Vec3 other) -> double:
        """Vector dot product"""
        return self.x * other.x + self.y * other.y + self.z * other.z

    def __xor__(self, Vec3 other):
        """Vector cross product"""
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y * other.z - self.z * other.y
        vec.y = self.z * other.x - self.x * other.z
        vec.z = self.x * other.y - self.y * other.x
        return vec


    def __len__(self):
        return 3

    def __getitem__(self, int key) -> double:
        if key == 0:
            return self.x
        elif key == 1:
            return self.y
        elif key == 2:
            return self.z
        else:
            raise KeyError(f"Vec3 index out of range: {key}")

    def __setitem__(self, int key, double value):
        if key == 0:
            self.x = value
        elif key == 1:
            self.y = value
        elif key == 2:
            self.z = value
        else:
            raise KeyError(f"Vec3 index out of range: {key}")

    def __iter__(self):
        cdef _Vec3iterator iterator = _Vec3iterator.__new__(_Vec3iterator)
        iterator.x = self.x
        iterator.y = self.y
        iterator.z = self.z
        # iterator.vec = self
        return iterator


    @property
    def length(self) -> float:
        return sqrt(self.x * self.x + self.y * self.y + self.z * self.z)

    @property
    def length_sqr(self) -> float:
        return self.x * self.x + self.y * self.y + self.z * self.z

    def __or__(self, other: Vec3) -> float:
        """Equivalent to distance_to()"""
        cdef double dx = self.x - other.x
        cdef double dy = self.y - other.y
        cdef double dz = self.z - other.z
        return sqrt(<double> (dx * dx + dy * dy + dz * dz))

    def distance_to(self, other: Vec3) -> float:
        cdef double dx = self.x - other.x
        cdef double dy = self.y - other.y
        cdef double dz = self.z - other.z
        return sqrt(<double> (dx * dx + dy * dy + dz * dz))

    def distance_sqr_to(self, other: Vec3) -> float:
        cdef double dx = self.x - other.x
        cdef double dy = self.y - other.y
        cdef double dz = self.z - other.z
        return <double> (dx * dx + dy * dy + dz * dz)

    @property
    def normalized(self) -> Vec3:
        cdef double l = sqrt(self.x * self.x + self.y * self.y + self.z * self.z)
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x / l
        vec.y = self.y / l
        vec.z = self.z / l
        return vec


    @property
    def xx(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x
        vec.y = self.x
        return vec
    
    @property
    def xy(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x
        vec.y = self.y
        return vec
    
    @property
    def xz(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x
        vec.y = self.z
        return vec
    
    @property
    def xo(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x
        vec.y = 0.0
        return vec
    
    @property
    def xl(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x
        vec.y = 1.0
        return vec
    
    @property
    def yx(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.y
        vec.y = self.x
        return vec
    
    @property
    def yy(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.y
        vec.y = self.y
        return vec
    
    @property
    def yz(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.y
        vec.y = self.z
        return vec
    
    @property
    def yo(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.y
        vec.y = 0.0
        return vec
    
    @property
    def yl(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.y
        vec.y = 1.0
        return vec
    
    @property
    def zx(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.z
        vec.y = self.x
        return vec
    
    @property
    def zy(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.z
        vec.y = self.y
        return vec
    
    @property
    def zz(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.z
        vec.y = self.z
        return vec
    
    @property
    def zo(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.z
        vec.y = 0.0
        return vec
    
    @property
    def zl(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.z
        vec.y = 1.0
        return vec
    
    @property
    def ox(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = 0.0
        vec.y = self.x
        return vec
    
    @property
    def oy(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = 0.0
        vec.y = self.y
        return vec
    
    @property
    def oz(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = 0.0
        vec.y = self.z
        return vec
    
    @property
    def lx(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = 1.0
        vec.y = self.x
        return vec
    
    @property
    def ly(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = 1.0
        vec.y = self.y
        return vec
    
    @property
    def lz(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = 1.0
        vec.y = self.z
        return vec
    
    @property
    def xxx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def xxy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def xxz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def xxo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0.0
        return vec
    
    @property
    def xxl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1.0
        return vec
    
    @property
    def xyx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def xyy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def xyz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @xyz.setter
    def xyz(self, Vec3 vec):
        self.x = vec.x
        self.y = vec.y
        self.z = vec.z
    
    @property
    def xyo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0.0
        return vec
    
    @property
    def xyl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1.0
        return vec
    
    @property
    def xzx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def xzy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @xzy.setter
    def xzy(self, Vec3 vec):
        self.x = vec.x
        self.z = vec.y
        self.y = vec.z
    
    @property
    def xzz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def xzo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0.0
        return vec
    
    @property
    def xzl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1.0
        return vec
    
    @property
    def xox(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.x
        return vec
    
    @property
    def xoy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.y
        return vec
    
    @property
    def xoz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.z
        return vec
    
    @property
    def xoo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 0.0
        return vec
    
    @property
    def xol(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 1.0
        return vec
    
    @property
    def xlx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.x
        return vec
    
    @property
    def xly(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.y
        return vec
    
    @property
    def xlz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.z
        return vec
    
    @property
    def xlo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 0.0
        return vec
    
    @property
    def xll(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 1.0
        return vec
    
    @property
    def yxx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def yxy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def yxz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @yxz.setter
    def yxz(self, Vec3 vec):
        self.y = vec.x
        self.x = vec.y
        self.z = vec.z
    
    @property
    def yxo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0.0
        return vec
    
    @property
    def yxl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1.0
        return vec
    
    @property
    def yyx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def yyy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def yyz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def yyo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0.0
        return vec
    
    @property
    def yyl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1.0
        return vec
    
    @property
    def yzx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @yzx.setter
    def yzx(self, Vec3 vec):
        self.y = vec.x
        self.z = vec.y
        self.x = vec.z
    
    @property
    def yzy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def yzz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def yzo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0.0
        return vec
    
    @property
    def yzl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1.0
        return vec
    
    @property
    def yox(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.x
        return vec
    
    @property
    def yoy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.y
        return vec
    
    @property
    def yoz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.z
        return vec
    
    @property
    def yoo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 0.0
        return vec
    
    @property
    def yol(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 1.0
        return vec
    
    @property
    def ylx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.x
        return vec
    
    @property
    def yly(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.y
        return vec
    
    @property
    def ylz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.z
        return vec
    
    @property
    def ylo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 0.0
        return vec
    
    @property
    def yll(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 1.0
        return vec
    
    @property
    def zxx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def zxy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @zxy.setter
    def zxy(self, Vec3 vec):
        self.z = vec.x
        self.x = vec.y
        self.y = vec.z
    
    @property
    def zxz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def zxo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0.0
        return vec
    
    @property
    def zxl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1.0
        return vec
    
    @property
    def zyx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @zyx.setter
    def zyx(self, Vec3 vec):
        self.z = vec.x
        self.y = vec.y
        self.x = vec.z
    
    @property
    def zyy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def zyz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def zyo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0.0
        return vec
    
    @property
    def zyl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1.0
        return vec
    
    @property
    def zzx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def zzy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def zzz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def zzo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0.0
        return vec
    
    @property
    def zzl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1.0
        return vec
    
    @property
    def zox(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.x
        return vec
    
    @property
    def zoy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.y
        return vec
    
    @property
    def zoz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.z
        return vec
    
    @property
    def zoo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 0.0
        return vec
    
    @property
    def zol(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 1.0
        return vec
    
    @property
    def zlx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.x
        return vec
    
    @property
    def zly(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.y
        return vec
    
    @property
    def zlz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.z
        return vec
    
    @property
    def zlo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 0.0
        return vec
    
    @property
    def zll(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 1.0
        return vec
    
    @property
    def oxx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def oxy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def oxz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def oxo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 0.0
        return vec
    
    @property
    def oxl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 1.0
        return vec
    
    @property
    def oyx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def oyy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def oyz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def oyo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 0.0
        return vec
    
    @property
    def oyl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 1.0
        return vec
    
    @property
    def ozx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def ozy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def ozz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def ozo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 0.0
        return vec
    
    @property
    def ozl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 1.0
        return vec
    
    @property
    def oox(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.x
        return vec
    
    @property
    def ooy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.y
        return vec
    
    @property
    def ooz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.z
        return vec
    
    @property
    def olx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.x
        return vec
    
    @property
    def oly(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.y
        return vec
    
    @property
    def olz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.z
        return vec
    
    @property
    def lxx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def lxy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def lxz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def lxo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 0.0
        return vec
    
    @property
    def lxl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 1.0
        return vec
    
    @property
    def lyx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def lyy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def lyz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def lyo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 0.0
        return vec
    
    @property
    def lyl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 1.0
        return vec
    
    @property
    def lzx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def lzy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def lzz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def lzo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 0.0
        return vec
    
    @property
    def lzl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 1.0
        return vec
    
    @property
    def lox(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.x
        return vec
    
    @property
    def loy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.y
        return vec
    
    @property
    def loz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.z
        return vec
    
    @property
    def llx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.x
        return vec
    
    @property
    def lly(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.y
        return vec
    
    @property
    def llz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.z
        return vec
    
    @property
    def xxxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xxxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xxxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xxxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def xxxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def xxyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xxyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xxyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xxyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def xxyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def xxzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xxzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xxzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xxzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def xxzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def xxox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def xxoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def xxoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def xxoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def xxol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def xxlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def xxly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def xxlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def xxlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def xxll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def xyxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xyxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xyxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xyxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def xyxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def xyyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xyyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xyyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xyyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def xyyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def xyzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xyzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xyzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xyzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def xyzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def xyox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def xyoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def xyoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def xyoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def xyol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def xylx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def xyly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def xylz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def xylo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def xyll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def xzxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xzxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xzxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xzxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def xzxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def xzyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xzyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xzyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xzyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def xzyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def xzzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xzzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xzzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xzzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def xzzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def xzox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def xzoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def xzoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def xzoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def xzol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def xzlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def xzly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def xzlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def xzlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def xzll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def xoxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xoxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xoxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xoxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def xoxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def xoyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xoyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xoyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xoyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def xoyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def xozx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xozy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xozz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xozo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def xozl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def xoox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def xooy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def xooz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def xooo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def xool(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def xolx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def xoly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def xolz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def xolo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def xoll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def xlxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xlxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xlxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xlxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def xlxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def xlyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xlyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xlyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xlyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def xlyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def xlzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xlzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xlzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xlzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def xlzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def xlox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def xloy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def xloz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def xloo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def xlol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def xllx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def xlly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def xllz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def xllo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def xlll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def yxxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yxxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yxxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def yxxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def yxxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def yxyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yxyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yxyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def yxyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def yxyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def yxzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def yxzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def yxzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def yxzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def yxzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def yxox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def yxoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def yxoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def yxoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def yxol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def yxlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def yxly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def yxlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def yxlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def yxll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def yyxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yyxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yyxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def yyxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def yyxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def yyyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yyyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yyyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def yyyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def yyyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def yyzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def yyzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def yyzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def yyzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def yyzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def yyox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def yyoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def yyoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def yyoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def yyol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def yylx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def yyly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def yylz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def yylo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def yyll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def yzxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yzxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yzxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def yzxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def yzxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def yzyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yzyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yzyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def yzyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def yzyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def yzzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def yzzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def yzzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def yzzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def yzzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def yzox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def yzoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def yzoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def yzoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def yzol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def yzlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def yzly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def yzlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def yzlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def yzll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def yoxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yoxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yoxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def yoxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def yoxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def yoyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yoyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yoyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def yoyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def yoyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def yozx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def yozy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def yozz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def yozo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def yozl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def yoox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def yooy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def yooz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def yooo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def yool(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def yolx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def yoly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def yolz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def yolo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def yoll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def ylxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def ylxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def ylxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def ylxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def ylxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def ylyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def ylyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def ylyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def ylyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def ylyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def ylzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def ylzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def ylzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def ylzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def ylzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def ylox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def yloy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def yloz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def yloo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def ylol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def yllx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def ylly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def yllz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def yllo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def ylll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def zxxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zxxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zxxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zxxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def zxxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def zxyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zxyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zxyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zxyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def zxyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def zxzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zxzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zxzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zxzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def zxzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def zxox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def zxoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def zxoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def zxoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def zxol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def zxlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def zxly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def zxlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def zxlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def zxll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def zyxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zyxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zyxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zyxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def zyxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def zyyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zyyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zyyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zyyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def zyyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def zyzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zyzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zyzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zyzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def zyzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def zyox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def zyoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def zyoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def zyoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def zyol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def zylx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def zyly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def zylz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def zylo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def zyll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def zzxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zzxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zzxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zzxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def zzxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def zzyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zzyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zzyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zzyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def zzyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def zzzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zzzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zzzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zzzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def zzzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def zzox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def zzoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def zzoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def zzoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def zzol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def zzlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def zzly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def zzlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def zzlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def zzll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def zoxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zoxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zoxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zoxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def zoxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def zoyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zoyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zoyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zoyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def zoyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def zozx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zozy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zozz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zozo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def zozl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def zoox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def zooy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def zooz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def zooo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def zool(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def zolx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def zoly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def zolz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def zolo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def zoll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def zlxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zlxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zlxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zlxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def zlxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def zlyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zlyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zlyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zlyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def zlyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def zlzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zlzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zlzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zlzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def zlzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def zlox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def zloy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def zloz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def zloo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def zlol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def zllx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def zlly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def zllz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def zllo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def zlll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def oxxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def oxxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def oxxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def oxxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def oxxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def oxyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def oxyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def oxyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def oxyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def oxyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def oxzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def oxzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def oxzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def oxzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def oxzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def oxox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def oxoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def oxoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def oxoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def oxol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def oxlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def oxly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def oxlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def oxlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def oxll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def oyxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def oyxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def oyxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def oyxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def oyxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def oyyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def oyyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def oyyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def oyyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def oyyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def oyzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def oyzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def oyzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def oyzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def oyzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def oyox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def oyoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def oyoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def oyoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def oyol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def oylx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def oyly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def oylz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def oylo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def oyll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def ozxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def ozxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def ozxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def ozxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def ozxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def ozyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def ozyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def ozyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def ozyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def ozyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def ozzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def ozzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def ozzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def ozzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def ozzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def ozox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def ozoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def ozoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def ozoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def ozol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def ozlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def ozly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def ozlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def ozlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def ozll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def ooxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def ooxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def ooxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def ooxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def ooxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def ooyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def ooyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def ooyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def ooyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def ooyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def oozx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def oozy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def oozz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def oozo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def oozl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def ooox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def oooy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def oooz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def oolx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def ooly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def oolz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def olxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def olxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def olxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def olxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def olxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def olyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def olyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def olyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def olyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def olyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def olzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def olzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def olzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def olzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def olzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def olox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def oloy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def oloz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def ollx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def olly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def ollz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def lxxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def lxxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def lxxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def lxxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def lxxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def lxyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def lxyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def lxyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def lxyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def lxyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def lxzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def lxzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def lxzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def lxzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def lxzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def lxox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def lxoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def lxoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def lxoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def lxol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def lxlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def lxly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def lxlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def lxlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def lxll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def lyxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def lyxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def lyxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def lyxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def lyxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def lyyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def lyyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def lyyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def lyyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def lyyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def lyzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def lyzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def lyzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def lyzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def lyzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def lyox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def lyoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def lyoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def lyoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def lyol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def lylx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def lyly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def lylz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def lylo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def lyll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def lzxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def lzxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def lzxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def lzxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def lzxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def lzyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def lzyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def lzyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def lzyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def lzyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def lzzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def lzzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def lzzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def lzzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def lzzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def lzox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def lzoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def lzoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def lzoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def lzol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def lzlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def lzly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def lzlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def lzlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def lzll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def loxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def loxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def loxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def loxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def loxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def loyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def loyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def loyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def loyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def loyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def lozx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def lozy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def lozz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def lozo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def lozl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def loox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def looy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def looz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def lolx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def loly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def lolz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def llxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def llxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def llxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def llxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def llxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def llyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def llyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def llyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def llyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def llyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def llzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def llzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def llzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def llzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def llzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def llox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def lloy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def lloz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def lllx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def llly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def lllz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.z
        return vec


@cython.no_gc
@cython.final
@cython.freelist(8)
cdef class _Vec3iterator:
    cdef public double x, y, z
    cdef short index


    def __next__(self):
        if self.index == 0:
            self.index += 1
            return self.x
        elif self.index == 1:
            self.index += 1
            return self.y
        elif self.index == 2:
            self.index += 1
            return self.z
        raise StopIteration

    def __iter__(self):
        return self

    def __length_hint__(self):
        return 3


@cython.freelist(4096)
@cython.no_gc
@cython.final
cdef class Vec4:
    cdef public double x, y, z, w


    cdef void ___init___0(self) noexcept:
        self.x = self.y = self.z = self.w = 0.0

    cdef void ___init___1(self, double value) noexcept:
        self.x = self.y = self.z = self.w = value

    cdef void ___init___2(self, Vec4i vec) noexcept:
        self.x = <double>vec.x
        self.y = <double>vec.y
        self.z = <double>vec.z
        self.w = <double>vec.w

    cdef void ___init___3(self, Vec4 xyzw) noexcept:
        self.x = xyzw.x
        self.y = xyzw.y
        self.z = xyzw.z
        self.w = xyzw.w
    
    cdef void ___init___4(self, double x, Vec3 yzw) noexcept:
        self.x = x
        self.y = yzw.x
        self.z = yzw.y
        self.w = yzw.z
    
    cdef void ___init___5(self, Vec2 xy, Vec2 zw) noexcept:
        self.x = xy.x
        self.y = xy.y
        self.z = zw.x
        self.w = zw.y
    
    cdef void ___init___6(self, Vec3 xyz, double w) noexcept:
        self.x = xyz.x
        self.y = xyz.y
        self.z = xyz.z
        self.w = w
    
    cdef void ___init___7(self, double x, double y, Vec2 zw) noexcept:
        self.x = x
        self.y = y
        self.z = zw.x
        self.w = zw.y
    
    cdef void ___init___8(self, double x, Vec2 yz, double w) noexcept:
        self.x = x
        self.y = yz.x
        self.z = yz.y
        self.w = w
    
    cdef void ___init___9(self, Vec2 xy, double z, double w) noexcept:
        self.x = xy.x
        self.y = xy.y
        self.z = z
        self.w = w
    
    cdef void ___init___10(self, double x, double y, double z, double w) noexcept:
        self.x = x
        self.y = y
        self.z = z
        self.w = w

    def __init__(self, p0=None, p1=None, p2=None, p3=None, /):
        if isinstance(p0, float):
            if isinstance(p1, Vec3):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, float, Vec3, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, float, Vec3, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, float, Vec3, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, float, Vec3, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, float, Vec3, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, float, Vec3, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, float, Vec3, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, float, Vec3, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, float, Vec3, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, float, Vec3, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, float, Vec3, None, int")
                    elif p3 is None:
                        self.___init___4(p0, p1)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, Vec2):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, float, Vec2, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, float, Vec2, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, float, Vec2, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, float, Vec2, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, float, Vec2, float, int")
                    elif p3 is None:
                        self.___init___8(p0, p1, p2)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, float, Vec2, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, float, Vec2, int, int")
                    elif p3 is None:
                        self.___init___8(p0, p1, p2)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, float, Vec2, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, float, Vec2, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, float, Vec2, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, float):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, float, float, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, float, float, Vec2, int")
                    elif p3 is None:
                        self.___init___7(p0, p1, p2)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        self.___init___10(p0, p1, p2, p3)
                        return
                    elif isinstance(p3, int):
                        self.___init___10(p0, p1, p2, p3)
                        return
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, float, float, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        self.___init___10(p0, p1, p2, p3)
                        return
                    elif isinstance(p3, int):
                        self.___init___10(p0, p1, p2, p3)
                        return
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, float, float, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, float, float, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, float, float, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, float, float, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, float, int, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, float, int, Vec2, int")
                    elif p3 is None:
                        self.___init___7(p0, p1, p2)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        self.___init___10(p0, p1, p2, p3)
                        return
                    elif isinstance(p3, int):
                        self.___init___10(p0, p1, p2, p3)
                        return
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, float, int, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        self.___init___10(p0, p1, p2, p3)
                        return
                    elif isinstance(p3, int):
                        self.___init___10(p0, p1, p2, p3)
                        return
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, float, int, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, float, int, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, float, int, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, float, int, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, float, None, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, float, None, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, float, None, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, float, None, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, float, None, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, float, None, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, float, None, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, float, None, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, float, None, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, float, None, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, float, None, None, int")
                    elif p3 is None:
                        self.___init___1(p0)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec3 | Vec2 | float | int | None, got {p1}")
        elif isinstance(p0, int):
            if isinstance(p1, Vec3):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec3, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec3, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, Vec3, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec3, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec3, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, Vec3, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec3, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec3, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, Vec3, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec3, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec3, None, int")
                    elif p3 is None:
                        self.___init___4(p0, p1)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, Vec2):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec2, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec2, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, Vec2, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec2, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec2, float, int")
                    elif p3 is None:
                        self.___init___8(p0, p1, p2)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec2, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec2, int, int")
                    elif p3 is None:
                        self.___init___8(p0, p1, p2)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec2, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec2, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, Vec2, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, float):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, int, float, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, float, Vec2, int")
                    elif p3 is None:
                        self.___init___7(p0, p1, p2)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        self.___init___10(p0, p1, p2, p3)
                        return
                    elif isinstance(p3, int):
                        self.___init___10(p0, p1, p2, p3)
                        return
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, float, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        self.___init___10(p0, p1, p2, p3)
                        return
                    elif isinstance(p3, int):
                        self.___init___10(p0, p1, p2, p3)
                        return
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, float, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, int, float, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, float, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, float, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, int, int, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, int, Vec2, int")
                    elif p3 is None:
                        self.___init___7(p0, p1, p2)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        self.___init___10(p0, p1, p2, p3)
                        return
                    elif isinstance(p3, int):
                        self.___init___10(p0, p1, p2, p3)
                        return
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, int, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        self.___init___10(p0, p1, p2, p3)
                        return
                    elif isinstance(p3, int):
                        self.___init___10(p0, p1, p2, p3)
                        return
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, int, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, int, int, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, int, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, int, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, int, None, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, None, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, None, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, int, None, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, None, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, None, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, int, None, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, None, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, None, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, int, None, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, None, None, int")
                    elif p3 is None:
                        self.___init___1(p0)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec3 | Vec2 | float | int | None, got {p1}")
        elif isinstance(p0, Vec4i):
            if isinstance(p1, Vec3):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec3, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec3, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec3, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec3, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec3, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec3, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec3, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec3, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec3, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec3, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec3, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec3, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, Vec2):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec2, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec2, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec2, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec2, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec2, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec2, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec2, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec2, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec2, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec2, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec2, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec2, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, float):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, float, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, float, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, float, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, float, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, float, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, float, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, float, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, float, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, float, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, float, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, float, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, float, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, int, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, int, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, int, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, int, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, int, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, int, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, int, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, int, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, int, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, int, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, int, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, int, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, None, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, None, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, None, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, None, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, None, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, None, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, None, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, None, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, None, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, None, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, None, None, int")
                    elif p3 is None:
                        self.___init___2(p0)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec3 | Vec2 | float | int | None, got {p1}")
        elif isinstance(p0, Vec4):
            if isinstance(p1, Vec3):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec3, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec3, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec3, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec3, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec3, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec3, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec3, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec3, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec3, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec3, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec3, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec3, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, Vec2):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec2, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec2, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec2, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec2, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec2, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec2, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec2, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec2, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec2, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec2, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec2, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec2, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, float):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, float, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, float, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, float, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, float, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, float, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, float, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, float, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, float, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, float, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, float, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, float, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, float, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, int, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, int, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, int, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, int, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, int, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, int, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, int, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, int, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, int, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, int, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, int, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, int, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, None, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, None, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, None, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, None, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, None, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, None, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, None, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, None, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, None, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, None, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, None, None, int")
                    elif p3 is None:
                        self.___init___3(p0)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec3 | Vec2 | float | int | None, got {p1}")
        elif isinstance(p0, Vec2):
            if isinstance(p1, Vec3):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec3, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec3, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec3, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec3, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec3, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec3, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec3, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec3, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec3, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec3, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec3, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec3, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, Vec2):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec2, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec2, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec2, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec2, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec2, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec2, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec2, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec2, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec2, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec2, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, Vec2, None, int")
                    elif p3 is None:
                        self.___init___5(p0, p1)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, float):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, float, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, float, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2, float, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, float, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, float, float, int")
                    elif p3 is None:
                        self.___init___9(p0, p1, p2)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, float, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, float, int, int")
                    elif p3 is None:
                        self.___init___9(p0, p1, p2)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, float, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, float, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2, float, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, int, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, int, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2, int, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, int, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, int, float, int")
                    elif p3 is None:
                        self.___init___9(p0, p1, p2)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, int, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, int, int, int")
                    elif p3 is None:
                        self.___init___9(p0, p1, p2)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, int, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, int, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2, int, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, None, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, None, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2, None, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, None, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, None, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2, None, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, None, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, None, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2, None, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, None, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2, None, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2, None, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec3 | Vec2 | float | int | None, got {p1}")
        elif isinstance(p0, Vec3):
            if isinstance(p1, Vec3):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec3, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec3, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec3, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec3, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec3, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec3, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec3, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec3, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec3, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec3, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec3, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec3, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, Vec2):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec2, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec2, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec2, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec2, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec2, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec2, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec2, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec2, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec2, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec2, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec2, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3, Vec2, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, float):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, float, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, float, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3, float, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, float, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, float, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3, float, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, float, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, float, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3, float, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, float, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, float, None, int")
                    elif p3 is None:
                        self.___init___6(p0, p1)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, int, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, int, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3, int, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, int, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, int, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3, int, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, int, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, int, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3, int, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, int, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, int, None, int")
                    elif p3 is None:
                        self.___init___6(p0, p1)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, None, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, None, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3, None, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, None, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, None, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3, None, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, None, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, None, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3, None, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, None, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3, None, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3, None, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec3 | Vec2 | float | int | None, got {p1}")
        elif p0 is None:
            if isinstance(p1, Vec3):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec3, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec3, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, Vec3, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec3, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec3, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, Vec3, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec3, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec3, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, Vec3, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec3, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec3, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, Vec3, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, Vec2):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec2, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec2, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, Vec2, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec2, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec2, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, Vec2, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec2, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec2, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, Vec2, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec2, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec2, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, Vec2, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, float):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, float, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, float, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, float, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, float, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, float, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, float, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, float, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, float, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, float, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, float, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, float, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, float, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, int, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, int, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, int, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, int, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, int, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, int, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, int, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, int, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, int, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, int, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, int, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, int, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, Vec2):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, None, Vec2, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, None, Vec2, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, None, Vec2, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, float):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, None, float, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, None, float, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, None, float, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, None, int, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, None, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, None, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, float):
                        raise TypeError("No matching overload function for parameter types: self, None, None, None, float")
                    elif isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, None, None, int")
                    elif p3 is None:
                        self.___init___0()
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected float | int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2 | float | int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec3 | Vec2 | float | int | None, got {p1}")
        else:
            raise TypeError(f"The 2th parameter expected float | int | Vec4i | Vec4 | Vec2 | Vec3 | None, got {p0}")


    def __repr__(self):
        return f"Vec4({self.x}, {self.y}, {self.z}, {self.w})"

    def __eq__(self, object other):
        if not isinstance(other, Vec4):
            return False
        return self.x == other.x and self.y == other.y and self.z == other.z and self.w == other.w

    def __ne__(self, object other):
        if not isinstance(other, Vec4):
            return True
        return self.x != other.x or self.y != other.y or self.z != other.z or self.w != other.w

    def __bool__(self):
        return self.x == 0 and self.y == 0 and self.z == 0 and self.w == 0

    def __pos__(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = self.w
        return vec

    def __neg__(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = -self.x
        vec.y = -self.y
        vec.z = -self.z
        vec.w = -self.w
        return vec

    cdef Vec4 ___add___0(self, Vec4 other) noexcept:
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x + other.x
        vec.y = self.y + other.y
        vec.z = self.z + other.z
        vec.w = self.w + other.w
        return vec
    
    cdef Vec4 ___add___1(self, double other) noexcept:
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x + other
        vec.y = self.y + other
        vec.z = self.z + other
        vec.w = self.w + other
        return vec
    
    def __add__(self, p0, /):
        if isinstance(p0, Vec4):
            return self.___add___0(p0)
        elif isinstance(p0, float):
            return self.___add___1(p0)
        elif isinstance(p0, int):
            return self.___add___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec4 | float | int, got {p0}")
    
    cdef Vec4 ___iadd___0(self, Vec4 other) noexcept:
        self.x += other.x
        self.y += other.y
        self.z += other.z
        self.w += other.w
        return self
    
    cdef Vec4 ___iadd___1(self, double other) noexcept:
        self.x += other
        self.y += other
        self.z += other
        self.w += other
        return self
    
    def __iadd__(self, p0, /):
        if isinstance(p0, Vec4):
            return self.___iadd___0(p0)
        elif isinstance(p0, float):
            return self.___iadd___1(p0)
        elif isinstance(p0, int):
            return self.___iadd___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec4 | float | int, got {p0}")

    cdef Vec4 ___sub___0(self, Vec4 other) noexcept:
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x - other.x
        vec.y = self.y - other.y
        vec.z = self.z - other.z
        vec.w = self.w - other.w
        return vec
    
    cdef Vec4 ___sub___1(self, double other) noexcept:
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x - other
        vec.y = self.y - other
        vec.z = self.z - other
        vec.w = self.w - other
        return vec
    
    def __sub__(self, p0, /):
        if isinstance(p0, Vec4):
            return self.___sub___0(p0)
        elif isinstance(p0, float):
            return self.___sub___1(p0)
        elif isinstance(p0, int):
            return self.___sub___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec4 | float | int, got {p0}")
    
    cdef Vec4 ___isub___0(self, Vec4 other) noexcept:
        self.x -= other.x
        self.y -= other.y
        self.z -= other.z
        self.w -= other.w
        return self
    
    cdef Vec4 ___isub___1(self, double other) noexcept:
        self.x -= other
        self.y -= other
        self.z -= other
        self.w -= other
        return self
    
    def __isub__(self, p0, /):
        if isinstance(p0, Vec4):
            return self.___isub___0(p0)
        elif isinstance(p0, float):
            return self.___isub___1(p0)
        elif isinstance(p0, int):
            return self.___isub___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec4 | float | int, got {p0}")

    cdef Vec4 ___mul___0(self, Vec4 other) noexcept:
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x * other.x
        vec.y = self.y * other.y
        vec.z = self.z * other.z
        vec.w = self.w * other.w
        return vec
    
    cdef Vec4 ___mul___1(self, double other) noexcept:
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x * other
        vec.y = self.y * other
        vec.z = self.z * other
        vec.w = self.w * other
        return vec
    
    def __mul__(self, p0, /):
        if isinstance(p0, Vec4):
            return self.___mul___0(p0)
        elif isinstance(p0, float):
            return self.___mul___1(p0)
        elif isinstance(p0, int):
            return self.___mul___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec4 | float | int, got {p0}")
    
    cdef Vec4 ___imul___0(self, Vec4 other) noexcept:
        self.x *= other.x
        self.y *= other.y
        self.z *= other.z
        self.w *= other.w
        return self
    
    cdef Vec4 ___imul___1(self, double other) noexcept:
        self.x *= other
        self.y *= other
        self.z *= other
        self.w *= other
        return self
    
    def __imul__(self, p0, /):
        if isinstance(p0, Vec4):
            return self.___imul___0(p0)
        elif isinstance(p0, float):
            return self.___imul___1(p0)
        elif isinstance(p0, int):
            return self.___imul___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec4 | float | int, got {p0}")

    cdef Vec4 ___truediv___0(self, Vec4 other) noexcept:
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x / other.x
        vec.y = self.y / other.y
        vec.z = self.z / other.z
        vec.w = self.w / other.w
        return vec
    
    cdef Vec4 ___truediv___1(self, double other) noexcept:
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x / other
        vec.y = self.y / other
        vec.z = self.z / other
        vec.w = self.w / other
        return vec
    
    def __truediv__(self, p0, /):
        if isinstance(p0, Vec4):
            return self.___truediv___0(p0)
        elif isinstance(p0, float):
            return self.___truediv___1(p0)
        elif isinstance(p0, int):
            return self.___truediv___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec4 | float | int, got {p0}")
    
    cdef Vec4 ___itruediv___0(self, Vec4 other) noexcept:
        self.x /= other.x
        self.y /= other.y
        self.z /= other.z
        self.w /= other.w
        return self
    
    cdef Vec4 ___itruediv___1(self, double other) noexcept:
        self.x /= other
        self.y /= other
        self.z /= other
        self.w /= other
        return self
    
    def __itruediv__(self, p0, /):
        if isinstance(p0, Vec4):
            return self.___itruediv___0(p0)
        elif isinstance(p0, float):
            return self.___itruediv___1(p0)
        elif isinstance(p0, int):
            return self.___itruediv___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec4 | float | int, got {p0}")

    def __matmul__(self, Vec4 other) -> double:
        """Vector dot product"""
        return self.x * other.x + self.y * other.y + self.z * other.z + self.w * other.w


    def __len__(self):
        return 4

    def __getitem__(self, int key) -> double:
        if key == 0:
            return self.x
        elif key == 1:
            return self.y
        elif key == 2:
            return self.z
        elif key == 3:
            return self.w
        else:
            raise KeyError(f"Vec4 index out of range: {key}")

    def __setitem__(self, int key, double value):
        if key == 0:
            self.x = value
        elif key == 1:
            self.y = value
        elif key == 2:
            self.z = value
        elif key == 3:
            self.w = value
        else:
            raise KeyError(f"Vec4 index out of range: {key}")

    def __iter__(self):
        cdef _Vec4iterator iterator = _Vec4iterator.__new__(_Vec4iterator)
        iterator.x = self.x
        iterator.y = self.y
        iterator.z = self.z
        iterator.w = self.w
        # iterator.vec = self
        return iterator


    @property
    def length(self) -> float:
        return sqrt(self.x * self.x + self.y * self.y + self.z * self.z + self.w * self.w)

    @property
    def length_sqr(self) -> float:
        return self.x * self.x + self.y * self.y + self.z * self.z + self.w * self.w

    def __or__(self, other: Vec4) -> float:
        """Equivalent to distance_to()"""
        cdef double dx = self.x - other.x
        cdef double dy = self.y - other.y
        cdef double dz = self.z - other.z
        cdef double dw = self.w - other.w
        return sqrt(<double> (dx * dx + dy * dy + dz * dz + dw * dw))

    def distance_to(self, other: Vec4) -> float:
        cdef double dx = self.x - other.x
        cdef double dy = self.y - other.y
        cdef double dz = self.z - other.z
        cdef double dw = self.w - other.w
        return sqrt(<double> (dx * dx + dy * dy + dz * dz + dw * dw))

    def distance_sqr_to(self, other: Vec4) -> float:
        cdef double dx = self.x - other.x
        cdef double dy = self.y - other.y
        cdef double dz = self.z - other.z
        cdef double dw = self.w - other.w
        return <double> (dx * dx + dy * dy + dz * dz + dw * dw)

    @property
    def normalized(self) -> Vec4:
        cdef double l = sqrt(self.x * self.x + self.y * self.y + self.z * self.z + self.w * self.w)
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x / l
        vec.y = self.y / l
        vec.z = self.z / l
        vec.w = self.w / l
        return vec


    @property
    def xx(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x
        vec.y = self.x
        return vec
    
    @property
    def xy(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x
        vec.y = self.y
        return vec
    
    @property
    def xz(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x
        vec.y = self.z
        return vec
    
    @property
    def xw(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x
        vec.y = self.w
        return vec
    
    @property
    def xo(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x
        vec.y = 0.0
        return vec
    
    @property
    def xl(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.x
        vec.y = 1.0
        return vec
    
    @property
    def yx(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.y
        vec.y = self.x
        return vec
    
    @property
    def yy(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.y
        vec.y = self.y
        return vec
    
    @property
    def yz(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.y
        vec.y = self.z
        return vec
    
    @property
    def yw(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.y
        vec.y = self.w
        return vec
    
    @property
    def yo(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.y
        vec.y = 0.0
        return vec
    
    @property
    def yl(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.y
        vec.y = 1.0
        return vec
    
    @property
    def zx(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.z
        vec.y = self.x
        return vec
    
    @property
    def zy(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.z
        vec.y = self.y
        return vec
    
    @property
    def zz(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.z
        vec.y = self.z
        return vec
    
    @property
    def zw(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.z
        vec.y = self.w
        return vec
    
    @property
    def zo(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.z
        vec.y = 0.0
        return vec
    
    @property
    def zl(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.z
        vec.y = 1.0
        return vec
    
    @property
    def wx(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.w
        vec.y = self.x
        return vec
    
    @property
    def wy(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.w
        vec.y = self.y
        return vec
    
    @property
    def wz(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.w
        vec.y = self.z
        return vec
    
    @property
    def ww(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.w
        vec.y = self.w
        return vec
    
    @property
    def wo(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.w
        vec.y = 0.0
        return vec
    
    @property
    def wl(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = self.w
        vec.y = 1.0
        return vec
    
    @property
    def ox(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = 0.0
        vec.y = self.x
        return vec
    
    @property
    def oy(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = 0.0
        vec.y = self.y
        return vec
    
    @property
    def oz(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = 0.0
        vec.y = self.z
        return vec
    
    @property
    def ow(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = 0.0
        vec.y = self.w
        return vec
    
    @property
    def lx(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = 1.0
        vec.y = self.x
        return vec
    
    @property
    def ly(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = 1.0
        vec.y = self.y
        return vec
    
    @property
    def lz(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = 1.0
        vec.y = self.z
        return vec
    
    @property
    def lw(self):
        cdef Vec2 vec = Vec2.__new__(Vec2)
        vec.x = 1.0
        vec.y = self.w
        return vec
    
    @property
    def xxx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def xxy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def xxz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def xxw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.w
        return vec
    
    @property
    def xxo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0.0
        return vec
    
    @property
    def xxl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1.0
        return vec
    
    @property
    def xyx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def xyy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def xyz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def xyw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.w
        return vec
    
    @property
    def xyo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0.0
        return vec
    
    @property
    def xyl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1.0
        return vec
    
    @property
    def xzx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def xzy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def xzz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def xzw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.w
        return vec
    
    @property
    def xzo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0.0
        return vec
    
    @property
    def xzl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1.0
        return vec
    
    @property
    def xwx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.x
        return vec
    
    @property
    def xwy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.y
        return vec
    
    @property
    def xwz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.z
        return vec
    
    @property
    def xww(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.w
        return vec
    
    @property
    def xwo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.w
        vec.z = 0.0
        return vec
    
    @property
    def xwl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = self.w
        vec.z = 1.0
        return vec
    
    @property
    def xox(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.x
        return vec
    
    @property
    def xoy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.y
        return vec
    
    @property
    def xoz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.z
        return vec
    
    @property
    def xow(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.w
        return vec
    
    @property
    def xoo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 0.0
        return vec
    
    @property
    def xol(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 1.0
        return vec
    
    @property
    def xlx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.x
        return vec
    
    @property
    def xly(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.y
        return vec
    
    @property
    def xlz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.z
        return vec
    
    @property
    def xlw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.w
        return vec
    
    @property
    def xlo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 0.0
        return vec
    
    @property
    def xll(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 1.0
        return vec
    
    @property
    def yxx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def yxy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def yxz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def yxw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.w
        return vec
    
    @property
    def yxo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0.0
        return vec
    
    @property
    def yxl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1.0
        return vec
    
    @property
    def yyx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def yyy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def yyz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def yyw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.w
        return vec
    
    @property
    def yyo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0.0
        return vec
    
    @property
    def yyl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1.0
        return vec
    
    @property
    def yzx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def yzy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def yzz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def yzw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.w
        return vec
    
    @property
    def yzo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0.0
        return vec
    
    @property
    def yzl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1.0
        return vec
    
    @property
    def ywx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.x
        return vec
    
    @property
    def ywy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.y
        return vec
    
    @property
    def ywz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.z
        return vec
    
    @property
    def yww(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.w
        return vec
    
    @property
    def ywo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.w
        vec.z = 0.0
        return vec
    
    @property
    def ywl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = self.w
        vec.z = 1.0
        return vec
    
    @property
    def yox(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.x
        return vec
    
    @property
    def yoy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.y
        return vec
    
    @property
    def yoz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.z
        return vec
    
    @property
    def yow(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.w
        return vec
    
    @property
    def yoo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 0.0
        return vec
    
    @property
    def yol(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 1.0
        return vec
    
    @property
    def ylx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.x
        return vec
    
    @property
    def yly(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.y
        return vec
    
    @property
    def ylz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.z
        return vec
    
    @property
    def ylw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.w
        return vec
    
    @property
    def ylo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 0.0
        return vec
    
    @property
    def yll(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 1.0
        return vec
    
    @property
    def zxx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def zxy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def zxz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def zxw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.w
        return vec
    
    @property
    def zxo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0.0
        return vec
    
    @property
    def zxl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1.0
        return vec
    
    @property
    def zyx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def zyy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def zyz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def zyw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.w
        return vec
    
    @property
    def zyo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0.0
        return vec
    
    @property
    def zyl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1.0
        return vec
    
    @property
    def zzx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def zzy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def zzz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def zzw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.w
        return vec
    
    @property
    def zzo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0.0
        return vec
    
    @property
    def zzl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1.0
        return vec
    
    @property
    def zwx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.x
        return vec
    
    @property
    def zwy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.y
        return vec
    
    @property
    def zwz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.z
        return vec
    
    @property
    def zww(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.w
        return vec
    
    @property
    def zwo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.w
        vec.z = 0.0
        return vec
    
    @property
    def zwl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = self.w
        vec.z = 1.0
        return vec
    
    @property
    def zox(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.x
        return vec
    
    @property
    def zoy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.y
        return vec
    
    @property
    def zoz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.z
        return vec
    
    @property
    def zow(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.w
        return vec
    
    @property
    def zoo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 0.0
        return vec
    
    @property
    def zol(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 1.0
        return vec
    
    @property
    def zlx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.x
        return vec
    
    @property
    def zly(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.y
        return vec
    
    @property
    def zlz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.z
        return vec
    
    @property
    def zlw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.w
        return vec
    
    @property
    def zlo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 0.0
        return vec
    
    @property
    def zll(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 1.0
        return vec
    
    @property
    def wxx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def wxy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def wxz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def wxw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.w
        return vec
    
    @property
    def wxo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.x
        vec.z = 0.0
        return vec
    
    @property
    def wxl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.x
        vec.z = 1.0
        return vec
    
    @property
    def wyx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def wyy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def wyz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def wyw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.w
        return vec
    
    @property
    def wyo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.y
        vec.z = 0.0
        return vec
    
    @property
    def wyl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.y
        vec.z = 1.0
        return vec
    
    @property
    def wzx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def wzy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def wzz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def wzw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.w
        return vec
    
    @property
    def wzo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.z
        vec.z = 0.0
        return vec
    
    @property
    def wzl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.z
        vec.z = 1.0
        return vec
    
    @property
    def wwx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.x
        return vec
    
    @property
    def wwy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.y
        return vec
    
    @property
    def wwz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.z
        return vec
    
    @property
    def www(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.w
        return vec
    
    @property
    def wwo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.w
        vec.z = 0.0
        return vec
    
    @property
    def wwl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = self.w
        vec.z = 1.0
        return vec
    
    @property
    def wox(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.x
        return vec
    
    @property
    def woy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.y
        return vec
    
    @property
    def woz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.z
        return vec
    
    @property
    def wow(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.w
        return vec
    
    @property
    def woo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = 0.0
        vec.z = 0.0
        return vec
    
    @property
    def wol(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = 0.0
        vec.z = 1.0
        return vec
    
    @property
    def wlx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.x
        return vec
    
    @property
    def wly(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.y
        return vec
    
    @property
    def wlz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.z
        return vec
    
    @property
    def wlw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.w
        return vec
    
    @property
    def wlo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = 1.0
        vec.z = 0.0
        return vec
    
    @property
    def wll(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = self.w
        vec.y = 1.0
        vec.z = 1.0
        return vec
    
    @property
    def oxx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def oxy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def oxz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def oxw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.w
        return vec
    
    @property
    def oxo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 0.0
        return vec
    
    @property
    def oxl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 1.0
        return vec
    
    @property
    def oyx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def oyy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def oyz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def oyw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.w
        return vec
    
    @property
    def oyo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 0.0
        return vec
    
    @property
    def oyl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 1.0
        return vec
    
    @property
    def ozx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def ozy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def ozz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def ozw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.w
        return vec
    
    @property
    def ozo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 0.0
        return vec
    
    @property
    def ozl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 1.0
        return vec
    
    @property
    def owx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.x
        return vec
    
    @property
    def owy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.y
        return vec
    
    @property
    def owz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.z
        return vec
    
    @property
    def oww(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.w
        return vec
    
    @property
    def owo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.w
        vec.z = 0.0
        return vec
    
    @property
    def owl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = self.w
        vec.z = 1.0
        return vec
    
    @property
    def oox(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.x
        return vec
    
    @property
    def ooy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.y
        return vec
    
    @property
    def ooz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.z
        return vec
    
    @property
    def oow(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.w
        return vec
    
    @property
    def olx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.x
        return vec
    
    @property
    def oly(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.y
        return vec
    
    @property
    def olz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.z
        return vec
    
    @property
    def olw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.w
        return vec
    
    @property
    def lxx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def lxy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def lxz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def lxw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.w
        return vec
    
    @property
    def lxo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 0.0
        return vec
    
    @property
    def lxl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 1.0
        return vec
    
    @property
    def lyx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def lyy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def lyz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def lyw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.w
        return vec
    
    @property
    def lyo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 0.0
        return vec
    
    @property
    def lyl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 1.0
        return vec
    
    @property
    def lzx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def lzy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def lzz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def lzw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.w
        return vec
    
    @property
    def lzo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 0.0
        return vec
    
    @property
    def lzl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 1.0
        return vec
    
    @property
    def lwx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.x
        return vec
    
    @property
    def lwy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.y
        return vec
    
    @property
    def lwz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.z
        return vec
    
    @property
    def lww(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.w
        return vec
    
    @property
    def lwo(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.w
        vec.z = 0.0
        return vec
    
    @property
    def lwl(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = self.w
        vec.z = 1.0
        return vec
    
    @property
    def lox(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.x
        return vec
    
    @property
    def loy(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.y
        return vec
    
    @property
    def loz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.z
        return vec
    
    @property
    def low(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.w
        return vec
    
    @property
    def llx(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.x
        return vec
    
    @property
    def lly(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.y
        return vec
    
    @property
    def llz(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.z
        return vec
    
    @property
    def llw(self):
        cdef Vec3 vec = Vec3.__new__(Vec3)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.w
        return vec
    
    @property
    def xxxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xxxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xxxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xxxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def xxxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def xxxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def xxyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xxyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xxyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xxyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def xxyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def xxyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def xxzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xxzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xxzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xxzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def xxzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def xxzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def xxwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def xxwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def xxwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def xxww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def xxwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def xxwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def xxox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def xxoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def xxoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def xxow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def xxoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def xxol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def xxlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def xxly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def xxlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def xxlw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def xxlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def xxll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def xyxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xyxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xyxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xyxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def xyxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def xyxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def xyyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xyyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xyyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xyyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def xyyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def xyyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def xyzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xyzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xyzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xyzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @xyzw.setter
    def xyzw(self, Vec4 vec):
        self.x = vec.x
        self.y = vec.y
        self.z = vec.z
        self.w = vec.w
    
    @property
    def xyzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def xyzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def xywx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def xywy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def xywz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @xywz.setter
    def xywz(self, Vec4 vec):
        self.x = vec.x
        self.y = vec.y
        self.w = vec.z
        self.z = vec.w
    
    @property
    def xyww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def xywo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def xywl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def xyox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def xyoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def xyoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def xyow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def xyoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def xyol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def xylx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def xyly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def xylz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def xylw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def xylo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def xyll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def xzxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xzxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xzxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xzxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def xzxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def xzxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def xzyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xzyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xzyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xzyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @xzyw.setter
    def xzyw(self, Vec4 vec):
        self.x = vec.x
        self.z = vec.y
        self.y = vec.z
        self.w = vec.w
    
    @property
    def xzyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def xzyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def xzzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xzzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xzzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xzzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def xzzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def xzzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def xzwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def xzwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @xzwy.setter
    def xzwy(self, Vec4 vec):
        self.x = vec.x
        self.z = vec.y
        self.w = vec.z
        self.y = vec.w
    
    @property
    def xzwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def xzww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def xzwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def xzwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def xzox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def xzoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def xzoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def xzow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def xzoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def xzol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def xzlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def xzly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def xzlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def xzlw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def xzlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def xzll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def xwxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xwxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xwxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xwxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def xwxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def xwxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def xwyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xwyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xwyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @xwyz.setter
    def xwyz(self, Vec4 vec):
        self.x = vec.x
        self.w = vec.y
        self.y = vec.z
        self.z = vec.w
    
    @property
    def xwyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def xwyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def xwyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def xwzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xwzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @xwzy.setter
    def xwzy(self, Vec4 vec):
        self.x = vec.x
        self.w = vec.y
        self.z = vec.z
        self.y = vec.w
    
    @property
    def xwzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xwzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def xwzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def xwzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def xwwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def xwwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def xwwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def xwww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def xwwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def xwwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def xwox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def xwoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def xwoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def xwow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def xwoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def xwol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def xwlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def xwly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def xwlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def xwlw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def xwlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def xwll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = self.w
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def xoxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xoxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xoxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xoxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def xoxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def xoxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def xoyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xoyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xoyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xoyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def xoyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def xoyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def xozx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xozy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xozz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xozw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def xozo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def xozl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def xowx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def xowy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def xowz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def xoww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def xowo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def xowl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def xoox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def xooy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def xooz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def xoow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def xooo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def xool(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def xolx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def xoly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def xolz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def xolw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def xolo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def xoll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 0.0
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def xlxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xlxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xlxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xlxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def xlxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def xlxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def xlyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xlyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xlyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xlyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def xlyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def xlyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def xlzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xlzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xlzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xlzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def xlzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def xlzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def xlwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def xlwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def xlwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def xlww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def xlwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def xlwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def xlox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def xloy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def xloz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def xlow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def xloo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def xlol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def xllx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def xlly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def xllz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def xllw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def xllo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def xlll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.x
        vec.y = 1.0
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def yxxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yxxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yxxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def yxxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def yxxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def yxxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def yxyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yxyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yxyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def yxyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def yxyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def yxyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def yxzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def yxzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def yxzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def yxzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @yxzw.setter
    def yxzw(self, Vec4 vec):
        self.y = vec.x
        self.x = vec.y
        self.z = vec.z
        self.w = vec.w
    
    @property
    def yxzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def yxzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def yxwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def yxwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def yxwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @yxwz.setter
    def yxwz(self, Vec4 vec):
        self.y = vec.x
        self.x = vec.y
        self.w = vec.z
        self.z = vec.w
    
    @property
    def yxww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def yxwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def yxwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def yxox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def yxoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def yxoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def yxow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def yxoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def yxol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def yxlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def yxly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def yxlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def yxlw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def yxlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def yxll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def yyxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yyxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yyxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def yyxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def yyxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def yyxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def yyyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yyyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yyyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def yyyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def yyyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def yyyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def yyzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def yyzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def yyzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def yyzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def yyzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def yyzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def yywx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def yywy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def yywz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def yyww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def yywo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def yywl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def yyox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def yyoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def yyoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def yyow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def yyoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def yyol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def yylx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def yyly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def yylz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def yylw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def yylo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def yyll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def yzxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yzxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yzxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def yzxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @yzxw.setter
    def yzxw(self, Vec4 vec):
        self.y = vec.x
        self.z = vec.y
        self.x = vec.z
        self.w = vec.w
    
    @property
    def yzxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def yzxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def yzyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yzyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yzyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def yzyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def yzyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def yzyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def yzzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def yzzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def yzzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def yzzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def yzzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def yzzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def yzwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @yzwx.setter
    def yzwx(self, Vec4 vec):
        self.y = vec.x
        self.z = vec.y
        self.w = vec.z
        self.x = vec.w
    
    @property
    def yzwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def yzwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def yzww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def yzwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def yzwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def yzox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def yzoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def yzoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def yzow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def yzoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def yzol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def yzlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def yzly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def yzlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def yzlw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def yzlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def yzll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def ywxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def ywxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def ywxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @ywxz.setter
    def ywxz(self, Vec4 vec):
        self.y = vec.x
        self.w = vec.y
        self.x = vec.z
        self.z = vec.w
    
    @property
    def ywxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def ywxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def ywxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def ywyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def ywyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def ywyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def ywyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def ywyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def ywyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def ywzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @ywzx.setter
    def ywzx(self, Vec4 vec):
        self.y = vec.x
        self.w = vec.y
        self.z = vec.z
        self.x = vec.w
    
    @property
    def ywzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def ywzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def ywzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def ywzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def ywzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def ywwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def ywwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def ywwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def ywww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def ywwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def ywwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def ywox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def ywoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def ywoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def ywow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def ywoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def ywol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def ywlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def ywly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def ywlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def ywlw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def ywlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def ywll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = self.w
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def yoxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yoxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yoxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def yoxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def yoxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def yoxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def yoyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yoyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yoyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def yoyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def yoyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def yoyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def yozx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def yozy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def yozz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def yozw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def yozo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def yozl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def yowx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def yowy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def yowz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def yoww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def yowo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def yowl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def yoox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def yooy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def yooz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def yoow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def yooo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def yool(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def yolx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def yoly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def yolz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def yolw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def yolo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def yoll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 0.0
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def ylxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def ylxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def ylxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def ylxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def ylxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def ylxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def ylyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def ylyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def ylyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def ylyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def ylyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def ylyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def ylzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def ylzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def ylzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def ylzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def ylzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def ylzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def ylwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def ylwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def ylwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def ylww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def ylwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def ylwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def ylox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def yloy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def yloz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def ylow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def yloo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def ylol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def yllx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def ylly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def yllz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def yllw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def yllo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def ylll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.y
        vec.y = 1.0
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def zxxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zxxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zxxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zxxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def zxxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def zxxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def zxyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zxyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zxyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zxyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @zxyw.setter
    def zxyw(self, Vec4 vec):
        self.z = vec.x
        self.x = vec.y
        self.y = vec.z
        self.w = vec.w
    
    @property
    def zxyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def zxyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def zxzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zxzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zxzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zxzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def zxzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def zxzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def zxwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def zxwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @zxwy.setter
    def zxwy(self, Vec4 vec):
        self.z = vec.x
        self.x = vec.y
        self.w = vec.z
        self.y = vec.w
    
    @property
    def zxwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def zxww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def zxwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def zxwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def zxox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def zxoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def zxoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def zxow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def zxoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def zxol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def zxlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def zxly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def zxlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def zxlw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def zxlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def zxll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def zyxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zyxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zyxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zyxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @zyxw.setter
    def zyxw(self, Vec4 vec):
        self.z = vec.x
        self.y = vec.y
        self.x = vec.z
        self.w = vec.w
    
    @property
    def zyxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def zyxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def zyyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zyyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zyyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zyyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def zyyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def zyyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def zyzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zyzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zyzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zyzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def zyzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def zyzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def zywx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @zywx.setter
    def zywx(self, Vec4 vec):
        self.z = vec.x
        self.y = vec.y
        self.w = vec.z
        self.x = vec.w
    
    @property
    def zywy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def zywz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def zyww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def zywo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def zywl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def zyox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def zyoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def zyoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def zyow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def zyoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def zyol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def zylx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def zyly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def zylz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def zylw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def zylo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def zyll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def zzxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zzxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zzxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zzxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def zzxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def zzxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def zzyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zzyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zzyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zzyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def zzyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def zzyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def zzzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zzzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zzzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zzzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def zzzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def zzzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def zzwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def zzwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def zzwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def zzww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def zzwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def zzwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def zzox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def zzoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def zzoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def zzow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def zzoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def zzol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def zzlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def zzly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def zzlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def zzlw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def zzlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def zzll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def zwxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zwxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @zwxy.setter
    def zwxy(self, Vec4 vec):
        self.z = vec.x
        self.w = vec.y
        self.x = vec.z
        self.y = vec.w
    
    @property
    def zwxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zwxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def zwxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def zwxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def zwyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @zwyx.setter
    def zwyx(self, Vec4 vec):
        self.z = vec.x
        self.w = vec.y
        self.y = vec.z
        self.x = vec.w
    
    @property
    def zwyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zwyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zwyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def zwyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def zwyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def zwzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zwzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zwzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zwzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def zwzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def zwzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def zwwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def zwwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def zwwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def zwww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def zwwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def zwwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def zwox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def zwoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def zwoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def zwow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def zwoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def zwol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def zwlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def zwly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def zwlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def zwlw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def zwlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def zwll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = self.w
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def zoxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zoxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zoxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zoxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def zoxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def zoxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def zoyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zoyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zoyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zoyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def zoyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def zoyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def zozx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zozy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zozz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zozw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def zozo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def zozl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def zowx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def zowy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def zowz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def zoww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def zowo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def zowl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def zoox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def zooy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def zooz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def zoow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def zooo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def zool(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def zolx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def zoly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def zolz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def zolw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def zolo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def zoll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 0.0
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def zlxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zlxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zlxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zlxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def zlxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def zlxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def zlyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zlyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zlyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zlyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def zlyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def zlyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def zlzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zlzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zlzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zlzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def zlzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def zlzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def zlwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def zlwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def zlwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def zlww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def zlwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def zlwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def zlox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def zloy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def zloz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def zlow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def zloo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def zlol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def zllx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def zlly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def zllz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def zllw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def zllo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def zlll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.z
        vec.y = 1.0
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def wxxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def wxxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def wxxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def wxxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def wxxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def wxxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def wxyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def wxyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def wxyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @wxyz.setter
    def wxyz(self, Vec4 vec):
        self.w = vec.x
        self.x = vec.y
        self.y = vec.z
        self.z = vec.w
    
    @property
    def wxyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def wxyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def wxyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def wxzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def wxzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @wxzy.setter
    def wxzy(self, Vec4 vec):
        self.w = vec.x
        self.x = vec.y
        self.z = vec.z
        self.y = vec.w
    
    @property
    def wxzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def wxzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def wxzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def wxzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def wxwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def wxwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def wxwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def wxww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def wxwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def wxwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def wxox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def wxoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def wxoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def wxow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def wxoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def wxol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def wxlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def wxly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def wxlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def wxlw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def wxlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def wxll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.x
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def wyxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def wyxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def wyxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @wyxz.setter
    def wyxz(self, Vec4 vec):
        self.w = vec.x
        self.y = vec.y
        self.x = vec.z
        self.z = vec.w
    
    @property
    def wyxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def wyxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def wyxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def wyyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def wyyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def wyyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def wyyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def wyyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def wyyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def wyzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @wyzx.setter
    def wyzx(self, Vec4 vec):
        self.w = vec.x
        self.y = vec.y
        self.z = vec.z
        self.x = vec.w
    
    @property
    def wyzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def wyzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def wyzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def wyzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def wyzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def wywx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def wywy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def wywz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def wyww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def wywo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def wywl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def wyox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def wyoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def wyoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def wyow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def wyoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def wyol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def wylx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def wyly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def wylz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def wylw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def wylo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def wyll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.y
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def wzxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def wzxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @wzxy.setter
    def wzxy(self, Vec4 vec):
        self.w = vec.x
        self.z = vec.y
        self.x = vec.z
        self.y = vec.w
    
    @property
    def wzxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def wzxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def wzxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def wzxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def wzyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @wzyx.setter
    def wzyx(self, Vec4 vec):
        self.w = vec.x
        self.z = vec.y
        self.y = vec.z
        self.x = vec.w
    
    @property
    def wzyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def wzyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def wzyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def wzyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def wzyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def wzzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def wzzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def wzzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def wzzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def wzzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def wzzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def wzwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def wzwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def wzwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def wzww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def wzwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def wzwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def wzox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def wzoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def wzoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def wzow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def wzoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def wzol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def wzlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def wzly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def wzlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def wzlw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def wzlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def wzll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.z
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def wwxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def wwxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def wwxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def wwxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def wwxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def wwxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def wwyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def wwyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def wwyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def wwyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def wwyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def wwyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def wwzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def wwzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def wwzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def wwzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def wwzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def wwzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def wwwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def wwwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def wwwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def wwww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def wwwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def wwwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def wwox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def wwoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def wwoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def wwow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def wwoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def wwol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def wwlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def wwly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def wwlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def wwlw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def wwlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def wwll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = self.w
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def woxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def woxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def woxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def woxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def woxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def woxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def woyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def woyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def woyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def woyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def woyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def woyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def wozx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def wozy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def wozz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def wozw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def wozo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def wozl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def wowx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def wowy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def wowz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def woww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def wowo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def wowl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def woox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def wooy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def wooz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def woow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def wooo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def wool(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def wolx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def woly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def wolz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def wolw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def wolo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def woll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 0.0
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def wlxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def wlxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def wlxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def wlxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def wlxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def wlxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def wlyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def wlyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def wlyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def wlyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def wlyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def wlyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def wlzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def wlzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def wlzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def wlzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def wlzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def wlzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def wlwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def wlwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def wlwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def wlww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def wlwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def wlwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def wlox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def wloy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def wloz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def wlow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def wloo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def wlol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def wllx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def wlly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def wllz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def wllw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def wllo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def wlll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = self.w
        vec.y = 1.0
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def oxxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def oxxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def oxxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def oxxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def oxxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def oxxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def oxyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def oxyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def oxyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def oxyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def oxyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def oxyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def oxzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def oxzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def oxzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def oxzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def oxzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def oxzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def oxwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def oxwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def oxwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def oxww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def oxwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def oxwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def oxox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def oxoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def oxoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def oxow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def oxoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def oxol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def oxlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def oxly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def oxlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def oxlw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def oxlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def oxll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def oyxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def oyxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def oyxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def oyxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def oyxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def oyxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def oyyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def oyyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def oyyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def oyyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def oyyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def oyyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def oyzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def oyzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def oyzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def oyzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def oyzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def oyzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def oywx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def oywy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def oywz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def oyww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def oywo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def oywl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def oyox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def oyoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def oyoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def oyow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def oyoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def oyol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def oylx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def oyly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def oylz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def oylw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def oylo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def oyll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def ozxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def ozxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def ozxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def ozxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def ozxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def ozxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def ozyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def ozyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def ozyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def ozyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def ozyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def ozyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def ozzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def ozzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def ozzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def ozzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def ozzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def ozzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def ozwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def ozwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def ozwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def ozww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def ozwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def ozwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def ozox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def ozoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def ozoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def ozow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def ozoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def ozol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def ozlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def ozly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def ozlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def ozlw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def ozlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def ozll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def owxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def owxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def owxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def owxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def owxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def owxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def owyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def owyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def owyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def owyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def owyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def owyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def owzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def owzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def owzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def owzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def owzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def owzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def owwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def owwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def owwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def owww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def owwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def owwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def owox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def owoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def owoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def owow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def owoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def owol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def owlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def owly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def owlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def owlw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def owlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def owll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = self.w
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def ooxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def ooxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def ooxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def ooxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def ooxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def ooxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def ooyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def ooyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def ooyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def ooyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def ooyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def ooyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def oozx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def oozy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def oozz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def oozw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def oozo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def oozl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def oowx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def oowy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def oowz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def ooww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def oowo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def oowl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def ooox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def oooy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def oooz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def ooow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def oolx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def ooly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def oolz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def oolw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def olxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def olxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def olxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def olxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def olxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def olxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def olyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def olyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def olyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def olyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def olyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def olyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def olzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def olzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def olzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def olzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def olzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def olzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def olwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def olwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def olwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def olww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def olwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def olwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def olox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def oloy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def oloz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def olow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def ollx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def olly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def ollz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def ollw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 0.0
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def lxxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def lxxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def lxxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def lxxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def lxxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def lxxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def lxyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def lxyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def lxyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def lxyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def lxyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def lxyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def lxzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def lxzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def lxzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def lxzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def lxzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def lxzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def lxwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def lxwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def lxwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def lxww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def lxwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def lxwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def lxox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def lxoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def lxoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def lxow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def lxoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def lxol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def lxlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def lxly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def lxlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def lxlw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def lxlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def lxll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.x
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def lyxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def lyxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def lyxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def lyxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def lyxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def lyxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def lyyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def lyyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def lyyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def lyyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def lyyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def lyyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def lyzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def lyzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def lyzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def lyzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def lyzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def lyzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def lywx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def lywy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def lywz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def lyww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def lywo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def lywl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def lyox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def lyoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def lyoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def lyow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def lyoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def lyol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def lylx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def lyly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def lylz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def lylw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def lylo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def lyll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.y
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def lzxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def lzxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def lzxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def lzxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def lzxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def lzxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def lzyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def lzyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def lzyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def lzyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def lzyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def lzyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def lzzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def lzzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def lzzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def lzzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def lzzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def lzzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def lzwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def lzwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def lzwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def lzww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def lzwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def lzwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def lzox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def lzoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def lzoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def lzow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def lzoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def lzol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def lzlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def lzly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def lzlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def lzlw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def lzlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def lzll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.z
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def lwxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def lwxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def lwxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def lwxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def lwxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def lwxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def lwyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def lwyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def lwyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def lwyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def lwyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def lwyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def lwzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def lwzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def lwzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def lwzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def lwzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def lwzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def lwwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def lwwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def lwwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def lwww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def lwwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def lwwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def lwox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def lwoy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def lwoz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def lwow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def lwoo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = 0.0
        vec.w = 0.0
        return vec
    
    @property
    def lwol(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = 0.0
        vec.w = 1.0
        return vec
    
    @property
    def lwlx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def lwly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def lwlz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def lwlw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def lwlo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = 1.0
        vec.w = 0.0
        return vec
    
    @property
    def lwll(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = self.w
        vec.z = 1.0
        vec.w = 1.0
        return vec
    
    @property
    def loxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def loxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def loxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def loxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def loxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def loxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def loyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def loyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def loyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def loyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def loyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def loyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def lozx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def lozy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def lozz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def lozw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def lozo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def lozl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def lowx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def lowy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def lowz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def loww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def lowo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def lowl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def loox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def looy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def looz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def loow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def lolx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def loly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def lolz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def lolw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 0.0
        vec.z = 1.0
        vec.w = self.w
        return vec
    
    @property
    def llxx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def llxy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def llxz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def llxw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def llxo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = 0.0
        return vec
    
    @property
    def llxl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.x
        vec.w = 1.0
        return vec
    
    @property
    def llyx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def llyy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def llyz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def llyw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def llyo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = 0.0
        return vec
    
    @property
    def llyl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.y
        vec.w = 1.0
        return vec
    
    @property
    def llzx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def llzy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def llzz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def llzw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def llzo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = 0.0
        return vec
    
    @property
    def llzl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.z
        vec.w = 1.0
        return vec
    
    @property
    def llwx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def llwy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def llwz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def llww(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def llwo(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.w
        vec.w = 0.0
        return vec
    
    @property
    def llwl(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = self.w
        vec.w = 1.0
        return vec
    
    @property
    def llox(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.x
        return vec
    
    @property
    def lloy(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.y
        return vec
    
    @property
    def lloz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.z
        return vec
    
    @property
    def llow(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = 0.0
        vec.w = self.w
        return vec
    
    @property
    def lllx(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.x
        return vec
    
    @property
    def llly(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.y
        return vec
    
    @property
    def lllz(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.z
        return vec
    
    @property
    def lllw(self):
        cdef Vec4 vec = Vec4.__new__(Vec4)
        vec.x = 1.0
        vec.y = 1.0
        vec.z = 1.0
        vec.w = self.w
        return vec


@cython.no_gc
@cython.final
@cython.freelist(8)
cdef class _Vec4iterator:
    cdef public double x, y, z, w
    cdef short index


    def __next__(self):
        if self.index == 0:
            self.index += 1
            return self.x
        elif self.index == 1:
            self.index += 1
            return self.y
        elif self.index == 2:
            self.index += 1
            return self.z
        elif self.index == 3:
            self.index += 1
            return self.w
        raise StopIteration

    def __iter__(self):
        return self

    def __length_hint__(self):
        return 4


@cython.freelist(4096)
@cython.no_gc
@cython.final
cdef class Vec2i:
    cdef public int x, y


    cdef void ___init___0(self) noexcept:
        self.x = self.y = 0

    cdef void ___init___1(self, int value) noexcept:
        self.x = self.y = value

    cdef void ___init___2(self, Vec2 vec) noexcept:
        self.x = <int>vec.x
        self.y = <int>vec.y

    cdef void ___init___3(self, Vec2i xy) noexcept:
        self.x = xy.x
        self.y = xy.y
    
    cdef void ___init___4(self, int x, int y) noexcept:
        self.x = x
        self.y = y

    def __init__(self, p0=None, p1=None, /):
        if isinstance(p0, int):
            if isinstance(p1, int):
                self.___init___4(p0, p1)
                return
            elif p1 is None:
                self.___init___1(p0)
                return
            else:
                raise TypeError(f"The 3th parameter expected int | None, got {p1}")
        elif isinstance(p0, Vec2):
            if isinstance(p1, int):
                raise TypeError("No matching overload function for parameter types: self, Vec2, int")
            elif p1 is None:
                self.___init___2(p0)
                return
            else:
                raise TypeError(f"The 3th parameter expected int | None, got {p1}")
        elif isinstance(p0, Vec2i):
            if isinstance(p1, int):
                raise TypeError("No matching overload function for parameter types: self, Vec2i, int")
            elif p1 is None:
                self.___init___3(p0)
                return
            else:
                raise TypeError(f"The 3th parameter expected int | None, got {p1}")
        elif p0 is None:
            if isinstance(p1, int):
                raise TypeError("No matching overload function for parameter types: self, None, int")
            elif p1 is None:
                self.___init___0()
                return
            else:
                raise TypeError(f"The 3th parameter expected int | None, got {p1}")
        else:
            raise TypeError(f"The 2th parameter expected int | Vec2 | Vec2i | None, got {p0}")


    def __repr__(self):
        return f"Vec2i({self.x}, {self.y})"

    def __eq__(self, object other):
        if not isinstance(other, Vec2i):
            return False
        return self.x == other.x and self.y == other.y

    def __ne__(self, object other):
        if not isinstance(other, Vec2i):
            return True
        return self.x != other.x or self.y != other.y

    def __bool__(self):
        return self.x == 0 and self.y == 0

    def __pos__(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x
        vec.y = self.y
        return vec

    def __neg__(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = -self.x
        vec.y = -self.y
        return vec

    cdef Vec2i ___add___0(self, Vec2i other) noexcept:
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x + other.x
        vec.y = self.y + other.y
        return vec
    
    cdef Vec2i ___add___1(self, int other) noexcept:
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x + other
        vec.y = self.y + other
        return vec
    
    def __add__(self, p0, /):
        if isinstance(p0, Vec2i):
            return self.___add___0(p0)
        elif isinstance(p0, int):
            return self.___add___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec2i | int, got {p0}")
    
    cdef Vec2i ___iadd___0(self, Vec2i other) noexcept:
        self.x += other.x
        self.y += other.y
        return self
    
    cdef Vec2i ___iadd___1(self, int other) noexcept:
        self.x += other
        self.y += other
        return self
    
    def __iadd__(self, p0, /):
        if isinstance(p0, Vec2i):
            return self.___iadd___0(p0)
        elif isinstance(p0, int):
            return self.___iadd___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec2i | int, got {p0}")

    cdef Vec2i ___sub___0(self, Vec2i other) noexcept:
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x - other.x
        vec.y = self.y - other.y
        return vec
    
    cdef Vec2i ___sub___1(self, int other) noexcept:
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x - other
        vec.y = self.y - other
        return vec
    
    def __sub__(self, p0, /):
        if isinstance(p0, Vec2i):
            return self.___sub___0(p0)
        elif isinstance(p0, int):
            return self.___sub___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec2i | int, got {p0}")
    
    cdef Vec2i ___isub___0(self, Vec2i other) noexcept:
        self.x -= other.x
        self.y -= other.y
        return self
    
    cdef Vec2i ___isub___1(self, int other) noexcept:
        self.x -= other
        self.y -= other
        return self
    
    def __isub__(self, p0, /):
        if isinstance(p0, Vec2i):
            return self.___isub___0(p0)
        elif isinstance(p0, int):
            return self.___isub___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec2i | int, got {p0}")

    cdef Vec2i ___mul___0(self, Vec2i other) noexcept:
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x * other.x
        vec.y = self.y * other.y
        return vec
    
    cdef Vec2i ___mul___1(self, int other) noexcept:
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x * other
        vec.y = self.y * other
        return vec
    
    def __mul__(self, p0, /):
        if isinstance(p0, Vec2i):
            return self.___mul___0(p0)
        elif isinstance(p0, int):
            return self.___mul___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec2i | int, got {p0}")
    
    cdef Vec2i ___imul___0(self, Vec2i other) noexcept:
        self.x *= other.x
        self.y *= other.y
        return self
    
    cdef Vec2i ___imul___1(self, int other) noexcept:
        self.x *= other
        self.y *= other
        return self
    
    def __imul__(self, p0, /):
        if isinstance(p0, Vec2i):
            return self.___imul___0(p0)
        elif isinstance(p0, int):
            return self.___imul___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec2i | int, got {p0}")

    cdef Vec2i ___truediv___0(self, Vec2i other) noexcept:
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x / other.x
        vec.y = self.y / other.y
        return vec
    
    cdef Vec2i ___truediv___1(self, int other) noexcept:
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x / other
        vec.y = self.y / other
        return vec
    
    def __truediv__(self, p0, /):
        if isinstance(p0, Vec2i):
            return self.___truediv___0(p0)
        elif isinstance(p0, int):
            return self.___truediv___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec2i | int, got {p0}")
    
    cdef Vec2i ___itruediv___0(self, Vec2i other) noexcept:
        self.x /= other.x
        self.y /= other.y
        return self
    
    cdef Vec2i ___itruediv___1(self, int other) noexcept:
        self.x /= other
        self.y /= other
        return self
    
    def __itruediv__(self, p0, /):
        if isinstance(p0, Vec2i):
            return self.___itruediv___0(p0)
        elif isinstance(p0, int):
            return self.___itruediv___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec2i | int, got {p0}")

    def __matmul__(self, Vec2i other) -> int:
        """Vector dot product"""
        return self.x * other.x + self.y * other.y


    def __len__(self):
        return 2

    def __getitem__(self, int key) -> int:
        if key == 0:
            return self.x
        elif key == 1:
            return self.y
        else:
            raise KeyError(f"Vec2i index out of range: {key}")

    def __setitem__(self, int key, int value):
        if key == 0:
            self.x = value
        elif key == 1:
            self.y = value
        else:
            raise KeyError(f"Vec2i index out of range: {key}")

    def __iter__(self):
        cdef _Vec2iiterator iterator = _Vec2iiterator.__new__(_Vec2iiterator)
        iterator.x = self.x
        iterator.y = self.y
        # iterator.vec = self
        return iterator


    @property
    def length(self) -> float:
        return sqrt(self.x * self.x + self.y * self.y)

    @property
    def length_sqr(self) -> float:
        return self.x * self.x + self.y * self.y

    def __or__(self, other: Vec2i) -> float:
        """Equivalent to distance_to()"""
        cdef int dx = self.x - other.x
        cdef int dy = self.y - other.y
        return sqrt(<double> (dx * dx + dy * dy))

    def distance_to(self, other: Vec2i) -> float:
        cdef int dx = self.x - other.x
        cdef int dy = self.y - other.y
        return sqrt(<double> (dx * dx + dy * dy))

    def distance_sqr_to(self, other: Vec2i) -> float:
        cdef int dx = self.x - other.x
        cdef int dy = self.y - other.y
        return <double> (dx * dx + dy * dy)


    @property
    def xx(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x
        vec.y = self.x
        return vec
    
    @property
    def xy(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x
        vec.y = self.y
        return vec
    
    @xy.setter
    def xy(self, Vec2i vec):
        self.x = vec.x
        self.y = vec.y
    
    @property
    def xo(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x
        vec.y = 0
        return vec
    
    @property
    def xl(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x
        vec.y = 1
        return vec
    
    @property
    def yx(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.y
        vec.y = self.x
        return vec
    
    @yx.setter
    def yx(self, Vec2i vec):
        self.y = vec.x
        self.x = vec.y
    
    @property
    def yy(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.y
        vec.y = self.y
        return vec
    
    @property
    def yo(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.y
        vec.y = 0
        return vec
    
    @property
    def yl(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.y
        vec.y = 1
        return vec
    
    @property
    def ox(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = 0
        vec.y = self.x
        return vec
    
    @property
    def oy(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = 0
        vec.y = self.y
        return vec
    
    @property
    def lx(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = 1
        vec.y = self.x
        return vec
    
    @property
    def ly(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = 1
        vec.y = self.y
        return vec
    
    @property
    def xxx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def xxy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def xxo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0
        return vec
    
    @property
    def xxl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1
        return vec
    
    @property
    def xyx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def xyy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def xyo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0
        return vec
    
    @property
    def xyl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1
        return vec
    
    @property
    def xox(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.x
        return vec
    
    @property
    def xoy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.y
        return vec
    
    @property
    def xoo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 0
        vec.z = 0
        return vec
    
    @property
    def xol(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 0
        vec.z = 1
        return vec
    
    @property
    def xlx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.x
        return vec
    
    @property
    def xly(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.y
        return vec
    
    @property
    def xlo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 1
        vec.z = 0
        return vec
    
    @property
    def xll(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 1
        vec.z = 1
        return vec
    
    @property
    def yxx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def yxy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def yxo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0
        return vec
    
    @property
    def yxl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1
        return vec
    
    @property
    def yyx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def yyy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def yyo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0
        return vec
    
    @property
    def yyl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1
        return vec
    
    @property
    def yox(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.x
        return vec
    
    @property
    def yoy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.y
        return vec
    
    @property
    def yoo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 0
        vec.z = 0
        return vec
    
    @property
    def yol(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 0
        vec.z = 1
        return vec
    
    @property
    def ylx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.x
        return vec
    
    @property
    def yly(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.y
        return vec
    
    @property
    def ylo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 1
        vec.z = 0
        return vec
    
    @property
    def yll(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 1
        vec.z = 1
        return vec
    
    @property
    def oxx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def oxy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def oxo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.x
        vec.z = 0
        return vec
    
    @property
    def oxl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.x
        vec.z = 1
        return vec
    
    @property
    def oyx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def oyy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def oyo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.y
        vec.z = 0
        return vec
    
    @property
    def oyl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.y
        vec.z = 1
        return vec
    
    @property
    def oox(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = 0
        vec.z = self.x
        return vec
    
    @property
    def ooy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = 0
        vec.z = self.y
        return vec
    
    @property
    def olx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = 1
        vec.z = self.x
        return vec
    
    @property
    def oly(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = 1
        vec.z = self.y
        return vec
    
    @property
    def lxx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def lxy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def lxo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.x
        vec.z = 0
        return vec
    
    @property
    def lxl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.x
        vec.z = 1
        return vec
    
    @property
    def lyx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def lyy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def lyo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.y
        vec.z = 0
        return vec
    
    @property
    def lyl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.y
        vec.z = 1
        return vec
    
    @property
    def lox(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = 0
        vec.z = self.x
        return vec
    
    @property
    def loy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = 0
        vec.z = self.y
        return vec
    
    @property
    def llx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = 1
        vec.z = self.x
        return vec
    
    @property
    def lly(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = 1
        vec.z = self.y
        return vec
    
    @property
    def xxxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xxxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xxxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def xxxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def xxyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xxyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xxyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def xxyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def xxox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def xxoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def xxoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def xxol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def xxlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def xxly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def xxlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def xxll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def xyxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xyxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xyxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def xyxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def xyyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xyyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xyyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def xyyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def xyox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def xyoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def xyoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def xyol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def xylx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def xyly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def xylo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def xyll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def xoxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xoxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xoxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def xoxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def xoyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xoyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xoyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def xoyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def xoox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def xooy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def xooo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def xool(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def xolx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def xoly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def xolo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def xoll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def xlxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xlxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xlxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def xlxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def xlyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xlyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xlyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def xlyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def xlox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def xloy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def xloo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def xlol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def xllx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def xlly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def xllo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def xlll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def yxxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yxxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yxxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def yxxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def yxyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yxyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yxyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def yxyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def yxox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def yxoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def yxoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def yxol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def yxlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def yxly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def yxlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def yxll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def yyxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yyxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yyxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def yyxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def yyyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yyyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yyyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def yyyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def yyox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def yyoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def yyoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def yyol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def yylx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def yyly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def yylo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def yyll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def yoxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yoxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yoxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def yoxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def yoyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yoyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yoyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def yoyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def yoox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def yooy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def yooo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def yool(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def yolx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def yoly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def yolo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def yoll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def ylxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def ylxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def ylxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def ylxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def ylyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def ylyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def ylyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def ylyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def ylox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def yloy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def yloo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def ylol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def yllx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def ylly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def yllo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def ylll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def oxxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def oxxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def oxxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def oxxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def oxyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def oxyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def oxyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def oxyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def oxox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def oxoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def oxoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def oxol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def oxlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def oxly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def oxlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def oxll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def oyxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def oyxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def oyxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def oyxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def oyyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def oyyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def oyyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def oyyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def oyox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def oyoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def oyoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def oyol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def oylx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def oyly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def oylo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def oyll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def ooxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def ooxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def ooxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def ooxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def ooyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def ooyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def ooyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def ooyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def ooox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def oooy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def oolx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def ooly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def olxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def olxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def olxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def olxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def olyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def olyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def olyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def olyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def olox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def oloy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def ollx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def olly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def lxxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def lxxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def lxxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def lxxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def lxyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def lxyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def lxyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def lxyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def lxox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def lxoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def lxoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def lxol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def lxlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def lxly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def lxlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def lxll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def lyxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def lyxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def lyxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def lyxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def lyyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def lyyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def lyyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def lyyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def lyox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def lyoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def lyoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def lyol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def lylx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def lyly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def lylo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def lyll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def loxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def loxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def loxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def loxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def loyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def loyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def loyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def loyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def loox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def looy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def lolx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def loly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def llxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def llxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def llxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def llxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def llyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def llyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def llyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def llyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def llox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def lloy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def lllx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def llly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = 1
        vec.w = self.y
        return vec


@cython.no_gc
@cython.final
@cython.freelist(8)
cdef class _Vec2iiterator:
    cdef public int x, y
    cdef short index


    def __next__(self):
        if self.index == 0:
            self.index += 1
            return self.x
        elif self.index == 1:
            self.index += 1
            return self.y
        raise StopIteration

    def __iter__(self):
        return self

    def __length_hint__(self):
        return 2


@cython.freelist(4096)
@cython.no_gc
@cython.final
cdef class Vec3i:
    cdef public int x, y, z


    cdef void ___init___0(self) noexcept:
        self.x = self.y = self.z = 0

    cdef void ___init___1(self, int value) noexcept:
        self.x = self.y = self.z = value

    cdef void ___init___2(self, Vec3 vec) noexcept:
        self.x = <int>vec.x
        self.y = <int>vec.y
        self.z = <int>vec.z

    cdef void ___init___3(self, Vec3i xyz) noexcept:
        self.x = xyz.x
        self.y = xyz.y
        self.z = xyz.z
    
    cdef void ___init___4(self, int x, Vec2i yz) noexcept:
        self.x = x
        self.y = yz.x
        self.z = yz.y
    
    cdef void ___init___5(self, Vec2i xy, int z) noexcept:
        self.x = xy.x
        self.y = xy.y
        self.z = z
    
    cdef void ___init___6(self, int x, int y, int z) noexcept:
        self.x = x
        self.y = y
        self.z = z

    def __init__(self, p0=None, p1=None, p2=None, /):
        if isinstance(p0, int):
            if isinstance(p1, Vec2i):
                if isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, int, Vec2i, int")
                elif p2 is None:
                    self.___init___4(p0, p1)
                    return
                else:
                    raise TypeError(f"The 4th parameter expected int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, int):
                    self.___init___6(p0, p1, p2)
                    return
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, int, int, None")
                else:
                    raise TypeError(f"The 4th parameter expected int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, int, None, int")
                elif p2 is None:
                    self.___init___1(p0)
                    return
                else:
                    raise TypeError(f"The 4th parameter expected int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec2i | int | None, got {p1}")
        elif isinstance(p0, Vec3):
            if isinstance(p1, Vec2i):
                if isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec3, Vec2i, int")
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, Vec3, Vec2i, None")
                else:
                    raise TypeError(f"The 4th parameter expected int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec3, int, int")
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, Vec3, int, None")
                else:
                    raise TypeError(f"The 4th parameter expected int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec3, None, int")
                elif p2 is None:
                    self.___init___2(p0)
                    return
                else:
                    raise TypeError(f"The 4th parameter expected int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec2i | int | None, got {p1}")
        elif isinstance(p0, Vec3i):
            if isinstance(p1, Vec2i):
                if isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec3i, Vec2i, int")
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, Vec3i, Vec2i, None")
                else:
                    raise TypeError(f"The 4th parameter expected int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec3i, int, int")
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, Vec3i, int, None")
                else:
                    raise TypeError(f"The 4th parameter expected int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec3i, None, int")
                elif p2 is None:
                    self.___init___3(p0)
                    return
                else:
                    raise TypeError(f"The 4th parameter expected int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec2i | int | None, got {p1}")
        elif isinstance(p0, Vec2i):
            if isinstance(p1, Vec2i):
                if isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec2i, Vec2i, int")
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, Vec2i, Vec2i, None")
                else:
                    raise TypeError(f"The 4th parameter expected int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec2i, int, int")
                elif p2 is None:
                    self.___init___5(p0, p1)
                    return
                else:
                    raise TypeError(f"The 4th parameter expected int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, Vec2i, None, int")
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, Vec2i, None, None")
                else:
                    raise TypeError(f"The 4th parameter expected int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec2i | int | None, got {p1}")
        elif p0 is None:
            if isinstance(p1, Vec2i):
                if isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, None, Vec2i, int")
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, None, Vec2i, None")
                else:
                    raise TypeError(f"The 4th parameter expected int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, None, int, int")
                elif p2 is None:
                    raise TypeError("No matching overload function for parameter types: self, None, int, None")
                else:
                    raise TypeError(f"The 4th parameter expected int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, int):
                    raise TypeError("No matching overload function for parameter types: self, None, None, int")
                elif p2 is None:
                    self.___init___0()
                    return
                else:
                    raise TypeError(f"The 4th parameter expected int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec2i | int | None, got {p1}")
        else:
            raise TypeError(f"The 2th parameter expected int | Vec3 | Vec3i | Vec2i | None, got {p0}")


    def __repr__(self):
        return f"Vec3i({self.x}, {self.y}, {self.z})"

    def __eq__(self, object other):
        if not isinstance(other, Vec3i):
            return False
        return self.x == other.x and self.y == other.y and self.z == other.z

    def __ne__(self, object other):
        if not isinstance(other, Vec3i):
            return True
        return self.x != other.x or self.y != other.y or self.z != other.z

    def __bool__(self):
        return self.x == 0 and self.y == 0 and self.z == 0

    def __pos__(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        return vec

    def __neg__(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = -self.x
        vec.y = -self.y
        vec.z = -self.z
        return vec

    cdef Vec3i ___add___0(self, Vec3i other) noexcept:
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x + other.x
        vec.y = self.y + other.y
        vec.z = self.z + other.z
        return vec
    
    cdef Vec3i ___add___1(self, int other) noexcept:
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x + other
        vec.y = self.y + other
        vec.z = self.z + other
        return vec
    
    def __add__(self, p0, /):
        if isinstance(p0, Vec3i):
            return self.___add___0(p0)
        elif isinstance(p0, int):
            return self.___add___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec3i | int, got {p0}")
    
    cdef Vec3i ___iadd___0(self, Vec3i other) noexcept:
        self.x += other.x
        self.y += other.y
        self.z += other.z
        return self
    
    cdef Vec3i ___iadd___1(self, int other) noexcept:
        self.x += other
        self.y += other
        self.z += other
        return self
    
    def __iadd__(self, p0, /):
        if isinstance(p0, Vec3i):
            return self.___iadd___0(p0)
        elif isinstance(p0, int):
            return self.___iadd___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec3i | int, got {p0}")

    cdef Vec3i ___sub___0(self, Vec3i other) noexcept:
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x - other.x
        vec.y = self.y - other.y
        vec.z = self.z - other.z
        return vec
    
    cdef Vec3i ___sub___1(self, int other) noexcept:
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x - other
        vec.y = self.y - other
        vec.z = self.z - other
        return vec
    
    def __sub__(self, p0, /):
        if isinstance(p0, Vec3i):
            return self.___sub___0(p0)
        elif isinstance(p0, int):
            return self.___sub___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec3i | int, got {p0}")
    
    cdef Vec3i ___isub___0(self, Vec3i other) noexcept:
        self.x -= other.x
        self.y -= other.y
        self.z -= other.z
        return self
    
    cdef Vec3i ___isub___1(self, int other) noexcept:
        self.x -= other
        self.y -= other
        self.z -= other
        return self
    
    def __isub__(self, p0, /):
        if isinstance(p0, Vec3i):
            return self.___isub___0(p0)
        elif isinstance(p0, int):
            return self.___isub___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec3i | int, got {p0}")

    cdef Vec3i ___mul___0(self, Vec3i other) noexcept:
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x * other.x
        vec.y = self.y * other.y
        vec.z = self.z * other.z
        return vec
    
    cdef Vec3i ___mul___1(self, int other) noexcept:
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x * other
        vec.y = self.y * other
        vec.z = self.z * other
        return vec
    
    def __mul__(self, p0, /):
        if isinstance(p0, Vec3i):
            return self.___mul___0(p0)
        elif isinstance(p0, int):
            return self.___mul___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec3i | int, got {p0}")
    
    cdef Vec3i ___imul___0(self, Vec3i other) noexcept:
        self.x *= other.x
        self.y *= other.y
        self.z *= other.z
        return self
    
    cdef Vec3i ___imul___1(self, int other) noexcept:
        self.x *= other
        self.y *= other
        self.z *= other
        return self
    
    def __imul__(self, p0, /):
        if isinstance(p0, Vec3i):
            return self.___imul___0(p0)
        elif isinstance(p0, int):
            return self.___imul___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec3i | int, got {p0}")

    cdef Vec3i ___truediv___0(self, Vec3i other) noexcept:
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x / other.x
        vec.y = self.y / other.y
        vec.z = self.z / other.z
        return vec
    
    cdef Vec3i ___truediv___1(self, int other) noexcept:
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x / other
        vec.y = self.y / other
        vec.z = self.z / other
        return vec
    
    def __truediv__(self, p0, /):
        if isinstance(p0, Vec3i):
            return self.___truediv___0(p0)
        elif isinstance(p0, int):
            return self.___truediv___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec3i | int, got {p0}")
    
    cdef Vec3i ___itruediv___0(self, Vec3i other) noexcept:
        self.x /= other.x
        self.y /= other.y
        self.z /= other.z
        return self
    
    cdef Vec3i ___itruediv___1(self, int other) noexcept:
        self.x /= other
        self.y /= other
        self.z /= other
        return self
    
    def __itruediv__(self, p0, /):
        if isinstance(p0, Vec3i):
            return self.___itruediv___0(p0)
        elif isinstance(p0, int):
            return self.___itruediv___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec3i | int, got {p0}")

    def __matmul__(self, Vec3i other) -> int:
        """Vector dot product"""
        return self.x * other.x + self.y * other.y + self.z * other.z

    def __xor__(self, Vec3i other):
        """Vector cross product"""
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y * other.z - self.z * other.y
        vec.y = self.z * other.x - self.x * other.z
        vec.z = self.x * other.y - self.y * other.x
        return vec


    def __len__(self):
        return 3

    def __getitem__(self, int key) -> int:
        if key == 0:
            return self.x
        elif key == 1:
            return self.y
        elif key == 2:
            return self.z
        else:
            raise KeyError(f"Vec3i index out of range: {key}")

    def __setitem__(self, int key, int value):
        if key == 0:
            self.x = value
        elif key == 1:
            self.y = value
        elif key == 2:
            self.z = value
        else:
            raise KeyError(f"Vec3i index out of range: {key}")

    def __iter__(self):
        cdef _Vec3iiterator iterator = _Vec3iiterator.__new__(_Vec3iiterator)
        iterator.x = self.x
        iterator.y = self.y
        iterator.z = self.z
        # iterator.vec = self
        return iterator


    @property
    def length(self) -> float:
        return sqrt(self.x * self.x + self.y * self.y + self.z * self.z)

    @property
    def length_sqr(self) -> float:
        return self.x * self.x + self.y * self.y + self.z * self.z

    def __or__(self, other: Vec3i) -> float:
        """Equivalent to distance_to()"""
        cdef int dx = self.x - other.x
        cdef int dy = self.y - other.y
        cdef int dz = self.z - other.z
        return sqrt(<double> (dx * dx + dy * dy + dz * dz))

    def distance_to(self, other: Vec3i) -> float:
        cdef int dx = self.x - other.x
        cdef int dy = self.y - other.y
        cdef int dz = self.z - other.z
        return sqrt(<double> (dx * dx + dy * dy + dz * dz))

    def distance_sqr_to(self, other: Vec3i) -> float:
        cdef int dx = self.x - other.x
        cdef int dy = self.y - other.y
        cdef int dz = self.z - other.z
        return <double> (dx * dx + dy * dy + dz * dz)


    @property
    def xx(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x
        vec.y = self.x
        return vec
    
    @property
    def xy(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x
        vec.y = self.y
        return vec
    
    @property
    def xz(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x
        vec.y = self.z
        return vec
    
    @property
    def xo(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x
        vec.y = 0
        return vec
    
    @property
    def xl(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x
        vec.y = 1
        return vec
    
    @property
    def yx(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.y
        vec.y = self.x
        return vec
    
    @property
    def yy(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.y
        vec.y = self.y
        return vec
    
    @property
    def yz(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.y
        vec.y = self.z
        return vec
    
    @property
    def yo(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.y
        vec.y = 0
        return vec
    
    @property
    def yl(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.y
        vec.y = 1
        return vec
    
    @property
    def zx(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.z
        vec.y = self.x
        return vec
    
    @property
    def zy(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.z
        vec.y = self.y
        return vec
    
    @property
    def zz(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.z
        vec.y = self.z
        return vec
    
    @property
    def zo(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.z
        vec.y = 0
        return vec
    
    @property
    def zl(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.z
        vec.y = 1
        return vec
    
    @property
    def ox(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = 0
        vec.y = self.x
        return vec
    
    @property
    def oy(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = 0
        vec.y = self.y
        return vec
    
    @property
    def oz(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = 0
        vec.y = self.z
        return vec
    
    @property
    def lx(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = 1
        vec.y = self.x
        return vec
    
    @property
    def ly(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = 1
        vec.y = self.y
        return vec
    
    @property
    def lz(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = 1
        vec.y = self.z
        return vec
    
    @property
    def xxx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def xxy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def xxz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def xxo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0
        return vec
    
    @property
    def xxl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1
        return vec
    
    @property
    def xyx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def xyy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def xyz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @xyz.setter
    def xyz(self, Vec3i vec):
        self.x = vec.x
        self.y = vec.y
        self.z = vec.z
    
    @property
    def xyo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0
        return vec
    
    @property
    def xyl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1
        return vec
    
    @property
    def xzx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def xzy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @xzy.setter
    def xzy(self, Vec3i vec):
        self.x = vec.x
        self.z = vec.y
        self.y = vec.z
    
    @property
    def xzz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def xzo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0
        return vec
    
    @property
    def xzl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1
        return vec
    
    @property
    def xox(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.x
        return vec
    
    @property
    def xoy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.y
        return vec
    
    @property
    def xoz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.z
        return vec
    
    @property
    def xoo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 0
        vec.z = 0
        return vec
    
    @property
    def xol(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 0
        vec.z = 1
        return vec
    
    @property
    def xlx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.x
        return vec
    
    @property
    def xly(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.y
        return vec
    
    @property
    def xlz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.z
        return vec
    
    @property
    def xlo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 1
        vec.z = 0
        return vec
    
    @property
    def xll(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 1
        vec.z = 1
        return vec
    
    @property
    def yxx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def yxy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def yxz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @yxz.setter
    def yxz(self, Vec3i vec):
        self.y = vec.x
        self.x = vec.y
        self.z = vec.z
    
    @property
    def yxo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0
        return vec
    
    @property
    def yxl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1
        return vec
    
    @property
    def yyx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def yyy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def yyz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def yyo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0
        return vec
    
    @property
    def yyl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1
        return vec
    
    @property
    def yzx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @yzx.setter
    def yzx(self, Vec3i vec):
        self.y = vec.x
        self.z = vec.y
        self.x = vec.z
    
    @property
    def yzy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def yzz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def yzo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0
        return vec
    
    @property
    def yzl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1
        return vec
    
    @property
    def yox(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.x
        return vec
    
    @property
    def yoy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.y
        return vec
    
    @property
    def yoz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.z
        return vec
    
    @property
    def yoo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 0
        vec.z = 0
        return vec
    
    @property
    def yol(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 0
        vec.z = 1
        return vec
    
    @property
    def ylx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.x
        return vec
    
    @property
    def yly(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.y
        return vec
    
    @property
    def ylz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.z
        return vec
    
    @property
    def ylo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 1
        vec.z = 0
        return vec
    
    @property
    def yll(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 1
        vec.z = 1
        return vec
    
    @property
    def zxx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def zxy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @zxy.setter
    def zxy(self, Vec3i vec):
        self.z = vec.x
        self.x = vec.y
        self.y = vec.z
    
    @property
    def zxz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def zxo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0
        return vec
    
    @property
    def zxl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1
        return vec
    
    @property
    def zyx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @zyx.setter
    def zyx(self, Vec3i vec):
        self.z = vec.x
        self.y = vec.y
        self.x = vec.z
    
    @property
    def zyy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def zyz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def zyo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0
        return vec
    
    @property
    def zyl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1
        return vec
    
    @property
    def zzx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def zzy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def zzz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def zzo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0
        return vec
    
    @property
    def zzl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1
        return vec
    
    @property
    def zox(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.x
        return vec
    
    @property
    def zoy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.y
        return vec
    
    @property
    def zoz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.z
        return vec
    
    @property
    def zoo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 0
        vec.z = 0
        return vec
    
    @property
    def zol(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 0
        vec.z = 1
        return vec
    
    @property
    def zlx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.x
        return vec
    
    @property
    def zly(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.y
        return vec
    
    @property
    def zlz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.z
        return vec
    
    @property
    def zlo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 1
        vec.z = 0
        return vec
    
    @property
    def zll(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 1
        vec.z = 1
        return vec
    
    @property
    def oxx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def oxy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def oxz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def oxo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.x
        vec.z = 0
        return vec
    
    @property
    def oxl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.x
        vec.z = 1
        return vec
    
    @property
    def oyx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def oyy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def oyz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def oyo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.y
        vec.z = 0
        return vec
    
    @property
    def oyl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.y
        vec.z = 1
        return vec
    
    @property
    def ozx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def ozy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def ozz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def ozo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.z
        vec.z = 0
        return vec
    
    @property
    def ozl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.z
        vec.z = 1
        return vec
    
    @property
    def oox(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = 0
        vec.z = self.x
        return vec
    
    @property
    def ooy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = 0
        vec.z = self.y
        return vec
    
    @property
    def ooz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = 0
        vec.z = self.z
        return vec
    
    @property
    def olx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = 1
        vec.z = self.x
        return vec
    
    @property
    def oly(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = 1
        vec.z = self.y
        return vec
    
    @property
    def olz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = 1
        vec.z = self.z
        return vec
    
    @property
    def lxx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def lxy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def lxz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def lxo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.x
        vec.z = 0
        return vec
    
    @property
    def lxl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.x
        vec.z = 1
        return vec
    
    @property
    def lyx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def lyy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def lyz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def lyo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.y
        vec.z = 0
        return vec
    
    @property
    def lyl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.y
        vec.z = 1
        return vec
    
    @property
    def lzx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def lzy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def lzz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def lzo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.z
        vec.z = 0
        return vec
    
    @property
    def lzl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.z
        vec.z = 1
        return vec
    
    @property
    def lox(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = 0
        vec.z = self.x
        return vec
    
    @property
    def loy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = 0
        vec.z = self.y
        return vec
    
    @property
    def loz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = 0
        vec.z = self.z
        return vec
    
    @property
    def llx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = 1
        vec.z = self.x
        return vec
    
    @property
    def lly(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = 1
        vec.z = self.y
        return vec
    
    @property
    def llz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = 1
        vec.z = self.z
        return vec
    
    @property
    def xxxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xxxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xxxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xxxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def xxxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def xxyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xxyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xxyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xxyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def xxyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def xxzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xxzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xxzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xxzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def xxzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def xxox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def xxoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def xxoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def xxoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def xxol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def xxlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def xxly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def xxlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def xxlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def xxll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def xyxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xyxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xyxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xyxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def xyxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def xyyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xyyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xyyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xyyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def xyyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def xyzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xyzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xyzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xyzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def xyzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def xyox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def xyoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def xyoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def xyoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def xyol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def xylx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def xyly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def xylz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def xylo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def xyll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def xzxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xzxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xzxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xzxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def xzxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def xzyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xzyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xzyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xzyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def xzyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def xzzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xzzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xzzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xzzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def xzzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def xzox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def xzoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def xzoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def xzoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def xzol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def xzlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def xzly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def xzlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def xzlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def xzll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def xoxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xoxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xoxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xoxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def xoxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def xoyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xoyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xoyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xoyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def xoyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def xozx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xozy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xozz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xozo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def xozl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def xoox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def xooy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def xooz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def xooo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def xool(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def xolx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def xoly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def xolz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def xolo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def xoll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def xlxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xlxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xlxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xlxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def xlxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def xlyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xlyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xlyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xlyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def xlyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def xlzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xlzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xlzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xlzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def xlzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def xlox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def xloy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def xloz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def xloo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def xlol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def xllx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def xlly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def xllz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def xllo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def xlll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def yxxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yxxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yxxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def yxxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def yxxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def yxyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yxyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yxyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def yxyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def yxyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def yxzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def yxzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def yxzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def yxzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def yxzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def yxox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def yxoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def yxoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def yxoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def yxol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def yxlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def yxly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def yxlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def yxlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def yxll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def yyxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yyxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yyxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def yyxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def yyxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def yyyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yyyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yyyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def yyyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def yyyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def yyzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def yyzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def yyzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def yyzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def yyzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def yyox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def yyoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def yyoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def yyoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def yyol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def yylx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def yyly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def yylz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def yylo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def yyll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def yzxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yzxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yzxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def yzxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def yzxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def yzyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yzyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yzyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def yzyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def yzyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def yzzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def yzzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def yzzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def yzzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def yzzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def yzox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def yzoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def yzoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def yzoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def yzol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def yzlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def yzly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def yzlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def yzlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def yzll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def yoxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yoxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yoxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def yoxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def yoxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def yoyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yoyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yoyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def yoyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def yoyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def yozx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def yozy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def yozz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def yozo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def yozl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def yoox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def yooy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def yooz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def yooo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def yool(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def yolx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def yoly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def yolz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def yolo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def yoll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def ylxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def ylxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def ylxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def ylxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def ylxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def ylyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def ylyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def ylyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def ylyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def ylyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def ylzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def ylzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def ylzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def ylzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def ylzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def ylox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def yloy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def yloz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def yloo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def ylol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def yllx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def ylly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def yllz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def yllo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def ylll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def zxxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zxxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zxxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zxxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def zxxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def zxyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zxyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zxyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zxyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def zxyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def zxzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zxzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zxzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zxzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def zxzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def zxox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def zxoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def zxoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def zxoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def zxol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def zxlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def zxly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def zxlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def zxlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def zxll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def zyxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zyxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zyxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zyxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def zyxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def zyyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zyyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zyyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zyyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def zyyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def zyzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zyzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zyzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zyzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def zyzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def zyox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def zyoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def zyoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def zyoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def zyol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def zylx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def zyly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def zylz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def zylo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def zyll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def zzxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zzxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zzxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zzxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def zzxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def zzyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zzyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zzyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zzyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def zzyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def zzzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zzzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zzzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zzzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def zzzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def zzox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def zzoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def zzoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def zzoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def zzol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def zzlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def zzly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def zzlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def zzlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def zzll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def zoxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zoxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zoxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zoxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def zoxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def zoyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zoyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zoyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zoyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def zoyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def zozx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zozy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zozz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zozo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def zozl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def zoox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def zooy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def zooz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def zooo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def zool(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def zolx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def zoly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def zolz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def zolo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def zoll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def zlxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zlxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zlxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zlxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def zlxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def zlyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zlyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zlyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zlyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def zlyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def zlzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zlzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zlzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zlzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def zlzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def zlox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def zloy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def zloz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def zloo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def zlol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def zllx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def zlly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def zllz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def zllo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def zlll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def oxxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def oxxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def oxxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def oxxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def oxxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def oxyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def oxyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def oxyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def oxyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def oxyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def oxzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def oxzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def oxzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def oxzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def oxzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def oxox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def oxoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def oxoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def oxoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def oxol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def oxlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def oxly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def oxlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def oxlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def oxll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def oyxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def oyxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def oyxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def oyxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def oyxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def oyyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def oyyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def oyyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def oyyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def oyyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def oyzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def oyzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def oyzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def oyzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def oyzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def oyox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def oyoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def oyoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def oyoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def oyol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def oylx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def oyly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def oylz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def oylo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def oyll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def ozxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def ozxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def ozxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def ozxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def ozxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def ozyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def ozyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def ozyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def ozyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def ozyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def ozzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def ozzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def ozzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def ozzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def ozzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def ozox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def ozoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def ozoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def ozoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def ozol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def ozlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def ozly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def ozlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def ozlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def ozll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def ooxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def ooxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def ooxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def ooxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def ooxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def ooyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def ooyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def ooyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def ooyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def ooyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def oozx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def oozy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def oozz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def oozo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def oozl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def ooox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def oooy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def oooz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def oolx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def ooly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def oolz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def olxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def olxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def olxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def olxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def olxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def olyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def olyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def olyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def olyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def olyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def olzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def olzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def olzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def olzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def olzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def olox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def oloy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def oloz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def ollx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def olly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def ollz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def lxxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def lxxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def lxxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def lxxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def lxxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def lxyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def lxyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def lxyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def lxyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def lxyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def lxzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def lxzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def lxzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def lxzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def lxzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def lxox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def lxoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def lxoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def lxoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def lxol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def lxlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def lxly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def lxlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def lxlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def lxll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def lyxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def lyxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def lyxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def lyxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def lyxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def lyyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def lyyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def lyyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def lyyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def lyyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def lyzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def lyzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def lyzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def lyzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def lyzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def lyox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def lyoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def lyoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def lyoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def lyol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def lylx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def lyly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def lylz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def lylo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def lyll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def lzxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def lzxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def lzxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def lzxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def lzxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def lzyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def lzyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def lzyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def lzyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def lzyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def lzzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def lzzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def lzzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def lzzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def lzzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def lzox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def lzoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def lzoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def lzoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def lzol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def lzlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def lzly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def lzlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def lzlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def lzll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def loxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def loxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def loxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def loxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def loxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def loyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def loyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def loyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def loyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def loyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def lozx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def lozy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def lozz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def lozo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def lozl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def loox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def looy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def looz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def lolx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def loly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def lolz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def llxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def llxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def llxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def llxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def llxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def llyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def llyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def llyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def llyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def llyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def llzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def llzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def llzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def llzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def llzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def llox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def lloy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def lloz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def lllx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def llly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def lllz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = 1
        vec.w = self.z
        return vec


@cython.no_gc
@cython.final
@cython.freelist(8)
cdef class _Vec3iiterator:
    cdef public int x, y, z
    cdef short index


    def __next__(self):
        if self.index == 0:
            self.index += 1
            return self.x
        elif self.index == 1:
            self.index += 1
            return self.y
        elif self.index == 2:
            self.index += 1
            return self.z
        raise StopIteration

    def __iter__(self):
        return self

    def __length_hint__(self):
        return 3


@cython.freelist(4096)
@cython.no_gc
@cython.final
cdef class Vec4i:
    cdef public int x, y, z, w


    cdef void ___init___0(self) noexcept:
        self.x = self.y = self.z = self.w = 0

    cdef void ___init___1(self, int value) noexcept:
        self.x = self.y = self.z = self.w = value

    cdef void ___init___2(self, Vec4 vec) noexcept:
        self.x = <int>vec.x
        self.y = <int>vec.y
        self.z = <int>vec.z
        self.w = <int>vec.w

    cdef void ___init___3(self, Vec4i xyzw) noexcept:
        self.x = xyzw.x
        self.y = xyzw.y
        self.z = xyzw.z
        self.w = xyzw.w
    
    cdef void ___init___4(self, int x, Vec3i yzw) noexcept:
        self.x = x
        self.y = yzw.x
        self.z = yzw.y
        self.w = yzw.z
    
    cdef void ___init___5(self, Vec2i xy, Vec2i zw) noexcept:
        self.x = xy.x
        self.y = xy.y
        self.z = zw.x
        self.w = zw.y
    
    cdef void ___init___6(self, Vec3i xyz, int w) noexcept:
        self.x = xyz.x
        self.y = xyz.y
        self.z = xyz.z
        self.w = w
    
    cdef void ___init___7(self, int x, int y, Vec2i zw) noexcept:
        self.x = x
        self.y = y
        self.z = zw.x
        self.w = zw.y
    
    cdef void ___init___8(self, int x, Vec2i yz, int w) noexcept:
        self.x = x
        self.y = yz.x
        self.z = yz.y
        self.w = w
    
    cdef void ___init___9(self, Vec2i xy, int z, int w) noexcept:
        self.x = xy.x
        self.y = xy.y
        self.z = z
        self.w = w
    
    cdef void ___init___10(self, int x, int y, int z, int w) noexcept:
        self.x = x
        self.y = y
        self.z = z
        self.w = w

    def __init__(self, p0=None, p1=None, p2=None, p3=None, /):
        if isinstance(p0, int):
            if isinstance(p1, Vec3i):
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec3i, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, Vec3i, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec3i, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, Vec3i, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec3i, None, int")
                    elif p3 is None:
                        self.___init___4(p0, p1)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            elif isinstance(p1, Vec2i):
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec2i, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, Vec2i, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec2i, int, int")
                    elif p3 is None:
                        self.___init___8(p0, p1, p2)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, Vec2i, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, Vec2i, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, int, Vec2i, int")
                    elif p3 is None:
                        self.___init___7(p0, p1, p2)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        self.___init___10(p0, p1, p2, p3)
                        return
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, int, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, int, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, int, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, None, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, None, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, None, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, int, None, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, int, None, None, int")
                    elif p3 is None:
                        self.___init___1(p0)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec3i | Vec2i | int | None, got {p1}")
        elif isinstance(p0, Vec4):
            if isinstance(p1, Vec3i):
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec3i, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec3i, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec3i, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec3i, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec3i, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec3i, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            elif isinstance(p1, Vec2i):
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec2i, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec2i, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec2i, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec2i, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec2i, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, Vec2i, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, int, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, int, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, int, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, int, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, int, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, int, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, None, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, None, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, None, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4, None, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4, None, None, int")
                    elif p3 is None:
                        self.___init___2(p0)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec3i | Vec2i | int | None, got {p1}")
        elif isinstance(p0, Vec4i):
            if isinstance(p1, Vec3i):
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec3i, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec3i, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec3i, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec3i, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec3i, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec3i, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            elif isinstance(p1, Vec2i):
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec2i, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec2i, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec2i, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec2i, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec2i, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, Vec2i, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, int, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, int, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, int, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, int, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, int, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, int, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, None, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, None, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, None, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, None, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec4i, None, None, int")
                    elif p3 is None:
                        self.___init___3(p0)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec3i | Vec2i | int | None, got {p1}")
        elif isinstance(p0, Vec2i):
            if isinstance(p1, Vec3i):
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, Vec3i, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, Vec3i, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, Vec3i, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, Vec3i, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, Vec3i, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, Vec3i, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            elif isinstance(p1, Vec2i):
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, Vec2i, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, Vec2i, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, Vec2i, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, Vec2i, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, Vec2i, None, int")
                    elif p3 is None:
                        self.___init___5(p0, p1)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, int, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, int, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, int, int, int")
                    elif p3 is None:
                        self.___init___9(p0, p1, p2)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, int, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, int, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, None, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, None, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, None, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, None, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, None, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec2i, None, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec3i | Vec2i | int | None, got {p1}")
        elif isinstance(p0, Vec3i):
            if isinstance(p1, Vec3i):
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, Vec3i, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, Vec3i, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, Vec3i, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, Vec3i, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, Vec3i, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, Vec3i, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            elif isinstance(p1, Vec2i):
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, Vec2i, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, Vec2i, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, Vec2i, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, Vec2i, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, Vec2i, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, Vec2i, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, int, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, int, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, int, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, int, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, int, None, int")
                    elif p3 is None:
                        self.___init___6(p0, p1)
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, None, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, None, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, None, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, None, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, None, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, Vec3i, None, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec3i | Vec2i | int | None, got {p1}")
        elif p0 is None:
            if isinstance(p1, Vec3i):
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec3i, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, Vec3i, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec3i, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, Vec3i, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec3i, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, Vec3i, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            elif isinstance(p1, Vec2i):
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec2i, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, Vec2i, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec2i, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, Vec2i, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, Vec2i, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, Vec2i, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            elif isinstance(p1, int):
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, int, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, int, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, int, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, int, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, int, None, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, int, None, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            elif p1 is None:
                if isinstance(p2, Vec2i):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, None, Vec2i, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, None, Vec2i, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif isinstance(p2, int):
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, None, int, int")
                    elif p3 is None:
                        raise TypeError("No matching overload function for parameter types: self, None, None, int, None")
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                elif p2 is None:
                    if isinstance(p3, int):
                        raise TypeError("No matching overload function for parameter types: self, None, None, None, int")
                    elif p3 is None:
                        self.___init___0()
                        return
                    else:
                        raise TypeError(f"The 5th parameter expected int | None, got {p3}")
                else:
                    raise TypeError(f"The 4th parameter expected Vec2i | int | None, got {p2}")
            else:
                raise TypeError(f"The 3th parameter expected Vec3i | Vec2i | int | None, got {p1}")
        else:
            raise TypeError(f"The 2th parameter expected int | Vec4 | Vec4i | Vec2i | Vec3i | None, got {p0}")


    def __repr__(self):
        return f"Vec4i({self.x}, {self.y}, {self.z}, {self.w})"

    def __eq__(self, object other):
        if not isinstance(other, Vec4i):
            return False
        return self.x == other.x and self.y == other.y and self.z == other.z and self.w == other.w

    def __ne__(self, object other):
        if not isinstance(other, Vec4i):
            return True
        return self.x != other.x or self.y != other.y or self.z != other.z or self.w != other.w

    def __bool__(self):
        return self.x == 0 and self.y == 0 and self.z == 0 and self.w == 0

    def __pos__(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = self.w
        return vec

    def __neg__(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = -self.x
        vec.y = -self.y
        vec.z = -self.z
        vec.w = -self.w
        return vec

    cdef Vec4i ___add___0(self, Vec4i other) noexcept:
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x + other.x
        vec.y = self.y + other.y
        vec.z = self.z + other.z
        vec.w = self.w + other.w
        return vec
    
    cdef Vec4i ___add___1(self, int other) noexcept:
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x + other
        vec.y = self.y + other
        vec.z = self.z + other
        vec.w = self.w + other
        return vec
    
    def __add__(self, p0, /):
        if isinstance(p0, Vec4i):
            return self.___add___0(p0)
        elif isinstance(p0, int):
            return self.___add___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec4i | int, got {p0}")
    
    cdef Vec4i ___iadd___0(self, Vec4i other) noexcept:
        self.x += other.x
        self.y += other.y
        self.z += other.z
        self.w += other.w
        return self
    
    cdef Vec4i ___iadd___1(self, int other) noexcept:
        self.x += other
        self.y += other
        self.z += other
        self.w += other
        return self
    
    def __iadd__(self, p0, /):
        if isinstance(p0, Vec4i):
            return self.___iadd___0(p0)
        elif isinstance(p0, int):
            return self.___iadd___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec4i | int, got {p0}")

    cdef Vec4i ___sub___0(self, Vec4i other) noexcept:
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x - other.x
        vec.y = self.y - other.y
        vec.z = self.z - other.z
        vec.w = self.w - other.w
        return vec
    
    cdef Vec4i ___sub___1(self, int other) noexcept:
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x - other
        vec.y = self.y - other
        vec.z = self.z - other
        vec.w = self.w - other
        return vec
    
    def __sub__(self, p0, /):
        if isinstance(p0, Vec4i):
            return self.___sub___0(p0)
        elif isinstance(p0, int):
            return self.___sub___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec4i | int, got {p0}")
    
    cdef Vec4i ___isub___0(self, Vec4i other) noexcept:
        self.x -= other.x
        self.y -= other.y
        self.z -= other.z
        self.w -= other.w
        return self
    
    cdef Vec4i ___isub___1(self, int other) noexcept:
        self.x -= other
        self.y -= other
        self.z -= other
        self.w -= other
        return self
    
    def __isub__(self, p0, /):
        if isinstance(p0, Vec4i):
            return self.___isub___0(p0)
        elif isinstance(p0, int):
            return self.___isub___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec4i | int, got {p0}")

    cdef Vec4i ___mul___0(self, Vec4i other) noexcept:
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x * other.x
        vec.y = self.y * other.y
        vec.z = self.z * other.z
        vec.w = self.w * other.w
        return vec
    
    cdef Vec4i ___mul___1(self, int other) noexcept:
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x * other
        vec.y = self.y * other
        vec.z = self.z * other
        vec.w = self.w * other
        return vec
    
    def __mul__(self, p0, /):
        if isinstance(p0, Vec4i):
            return self.___mul___0(p0)
        elif isinstance(p0, int):
            return self.___mul___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec4i | int, got {p0}")
    
    cdef Vec4i ___imul___0(self, Vec4i other) noexcept:
        self.x *= other.x
        self.y *= other.y
        self.z *= other.z
        self.w *= other.w
        return self
    
    cdef Vec4i ___imul___1(self, int other) noexcept:
        self.x *= other
        self.y *= other
        self.z *= other
        self.w *= other
        return self
    
    def __imul__(self, p0, /):
        if isinstance(p0, Vec4i):
            return self.___imul___0(p0)
        elif isinstance(p0, int):
            return self.___imul___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec4i | int, got {p0}")

    cdef Vec4i ___truediv___0(self, Vec4i other) noexcept:
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x / other.x
        vec.y = self.y / other.y
        vec.z = self.z / other.z
        vec.w = self.w / other.w
        return vec
    
    cdef Vec4i ___truediv___1(self, int other) noexcept:
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x / other
        vec.y = self.y / other
        vec.z = self.z / other
        vec.w = self.w / other
        return vec
    
    def __truediv__(self, p0, /):
        if isinstance(p0, Vec4i):
            return self.___truediv___0(p0)
        elif isinstance(p0, int):
            return self.___truediv___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec4i | int, got {p0}")
    
    cdef Vec4i ___itruediv___0(self, Vec4i other) noexcept:
        self.x /= other.x
        self.y /= other.y
        self.z /= other.z
        self.w /= other.w
        return self
    
    cdef Vec4i ___itruediv___1(self, int other) noexcept:
        self.x /= other
        self.y /= other
        self.z /= other
        self.w /= other
        return self
    
    def __itruediv__(self, p0, /):
        if isinstance(p0, Vec4i):
            return self.___itruediv___0(p0)
        elif isinstance(p0, int):
            return self.___itruediv___1(p0)
        else:
            raise TypeError(f"The 2th parameter expected Vec4i | int, got {p0}")

    def __matmul__(self, Vec4i other) -> int:
        """Vector dot product"""
        return self.x * other.x + self.y * other.y + self.z * other.z + self.w * other.w


    def __len__(self):
        return 4

    def __getitem__(self, int key) -> int:
        if key == 0:
            return self.x
        elif key == 1:
            return self.y
        elif key == 2:
            return self.z
        elif key == 3:
            return self.w
        else:
            raise KeyError(f"Vec4i index out of range: {key}")

    def __setitem__(self, int key, int value):
        if key == 0:
            self.x = value
        elif key == 1:
            self.y = value
        elif key == 2:
            self.z = value
        elif key == 3:
            self.w = value
        else:
            raise KeyError(f"Vec4i index out of range: {key}")

    def __iter__(self):
        cdef _Vec4iiterator iterator = _Vec4iiterator.__new__(_Vec4iiterator)
        iterator.x = self.x
        iterator.y = self.y
        iterator.z = self.z
        iterator.w = self.w
        # iterator.vec = self
        return iterator


    @property
    def length(self) -> float:
        return sqrt(self.x * self.x + self.y * self.y + self.z * self.z + self.w * self.w)

    @property
    def length_sqr(self) -> float:
        return self.x * self.x + self.y * self.y + self.z * self.z + self.w * self.w

    def __or__(self, other: Vec4i) -> float:
        """Equivalent to distance_to()"""
        cdef int dx = self.x - other.x
        cdef int dy = self.y - other.y
        cdef int dz = self.z - other.z
        cdef int dw = self.w - other.w
        return sqrt(<double> (dx * dx + dy * dy + dz * dz + dw * dw))

    def distance_to(self, other: Vec4i) -> float:
        cdef int dx = self.x - other.x
        cdef int dy = self.y - other.y
        cdef int dz = self.z - other.z
        cdef int dw = self.w - other.w
        return sqrt(<double> (dx * dx + dy * dy + dz * dz + dw * dw))

    def distance_sqr_to(self, other: Vec4i) -> float:
        cdef int dx = self.x - other.x
        cdef int dy = self.y - other.y
        cdef int dz = self.z - other.z
        cdef int dw = self.w - other.w
        return <double> (dx * dx + dy * dy + dz * dz + dw * dw)


    @property
    def xx(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x
        vec.y = self.x
        return vec
    
    @property
    def xy(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x
        vec.y = self.y
        return vec
    
    @property
    def xz(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x
        vec.y = self.z
        return vec
    
    @property
    def xw(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x
        vec.y = self.w
        return vec
    
    @property
    def xo(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x
        vec.y = 0
        return vec
    
    @property
    def xl(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.x
        vec.y = 1
        return vec
    
    @property
    def yx(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.y
        vec.y = self.x
        return vec
    
    @property
    def yy(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.y
        vec.y = self.y
        return vec
    
    @property
    def yz(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.y
        vec.y = self.z
        return vec
    
    @property
    def yw(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.y
        vec.y = self.w
        return vec
    
    @property
    def yo(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.y
        vec.y = 0
        return vec
    
    @property
    def yl(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.y
        vec.y = 1
        return vec
    
    @property
    def zx(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.z
        vec.y = self.x
        return vec
    
    @property
    def zy(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.z
        vec.y = self.y
        return vec
    
    @property
    def zz(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.z
        vec.y = self.z
        return vec
    
    @property
    def zw(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.z
        vec.y = self.w
        return vec
    
    @property
    def zo(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.z
        vec.y = 0
        return vec
    
    @property
    def zl(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.z
        vec.y = 1
        return vec
    
    @property
    def wx(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.w
        vec.y = self.x
        return vec
    
    @property
    def wy(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.w
        vec.y = self.y
        return vec
    
    @property
    def wz(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.w
        vec.y = self.z
        return vec
    
    @property
    def ww(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.w
        vec.y = self.w
        return vec
    
    @property
    def wo(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.w
        vec.y = 0
        return vec
    
    @property
    def wl(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = self.w
        vec.y = 1
        return vec
    
    @property
    def ox(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = 0
        vec.y = self.x
        return vec
    
    @property
    def oy(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = 0
        vec.y = self.y
        return vec
    
    @property
    def oz(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = 0
        vec.y = self.z
        return vec
    
    @property
    def ow(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = 0
        vec.y = self.w
        return vec
    
    @property
    def lx(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = 1
        vec.y = self.x
        return vec
    
    @property
    def ly(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = 1
        vec.y = self.y
        return vec
    
    @property
    def lz(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = 1
        vec.y = self.z
        return vec
    
    @property
    def lw(self):
        cdef Vec2i vec = Vec2i.__new__(Vec2i)
        vec.x = 1
        vec.y = self.w
        return vec
    
    @property
    def xxx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def xxy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def xxz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def xxw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.w
        return vec
    
    @property
    def xxo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0
        return vec
    
    @property
    def xxl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1
        return vec
    
    @property
    def xyx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def xyy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def xyz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def xyw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.w
        return vec
    
    @property
    def xyo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0
        return vec
    
    @property
    def xyl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1
        return vec
    
    @property
    def xzx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def xzy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def xzz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def xzw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.w
        return vec
    
    @property
    def xzo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0
        return vec
    
    @property
    def xzl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1
        return vec
    
    @property
    def xwx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.x
        return vec
    
    @property
    def xwy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.y
        return vec
    
    @property
    def xwz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.z
        return vec
    
    @property
    def xww(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.w
        return vec
    
    @property
    def xwo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.w
        vec.z = 0
        return vec
    
    @property
    def xwl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = self.w
        vec.z = 1
        return vec
    
    @property
    def xox(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.x
        return vec
    
    @property
    def xoy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.y
        return vec
    
    @property
    def xoz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.z
        return vec
    
    @property
    def xow(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.w
        return vec
    
    @property
    def xoo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 0
        vec.z = 0
        return vec
    
    @property
    def xol(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 0
        vec.z = 1
        return vec
    
    @property
    def xlx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.x
        return vec
    
    @property
    def xly(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.y
        return vec
    
    @property
    def xlz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.z
        return vec
    
    @property
    def xlw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.w
        return vec
    
    @property
    def xlo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 1
        vec.z = 0
        return vec
    
    @property
    def xll(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.x
        vec.y = 1
        vec.z = 1
        return vec
    
    @property
    def yxx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def yxy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def yxz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def yxw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.w
        return vec
    
    @property
    def yxo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0
        return vec
    
    @property
    def yxl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1
        return vec
    
    @property
    def yyx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def yyy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def yyz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def yyw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.w
        return vec
    
    @property
    def yyo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0
        return vec
    
    @property
    def yyl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1
        return vec
    
    @property
    def yzx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def yzy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def yzz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def yzw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.w
        return vec
    
    @property
    def yzo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0
        return vec
    
    @property
    def yzl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1
        return vec
    
    @property
    def ywx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.x
        return vec
    
    @property
    def ywy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.y
        return vec
    
    @property
    def ywz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.z
        return vec
    
    @property
    def yww(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.w
        return vec
    
    @property
    def ywo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.w
        vec.z = 0
        return vec
    
    @property
    def ywl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = self.w
        vec.z = 1
        return vec
    
    @property
    def yox(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.x
        return vec
    
    @property
    def yoy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.y
        return vec
    
    @property
    def yoz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.z
        return vec
    
    @property
    def yow(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.w
        return vec
    
    @property
    def yoo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 0
        vec.z = 0
        return vec
    
    @property
    def yol(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 0
        vec.z = 1
        return vec
    
    @property
    def ylx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.x
        return vec
    
    @property
    def yly(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.y
        return vec
    
    @property
    def ylz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.z
        return vec
    
    @property
    def ylw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.w
        return vec
    
    @property
    def ylo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 1
        vec.z = 0
        return vec
    
    @property
    def yll(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.y
        vec.y = 1
        vec.z = 1
        return vec
    
    @property
    def zxx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def zxy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def zxz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def zxw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.w
        return vec
    
    @property
    def zxo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0
        return vec
    
    @property
    def zxl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1
        return vec
    
    @property
    def zyx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def zyy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def zyz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def zyw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.w
        return vec
    
    @property
    def zyo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0
        return vec
    
    @property
    def zyl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1
        return vec
    
    @property
    def zzx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def zzy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def zzz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def zzw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.w
        return vec
    
    @property
    def zzo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0
        return vec
    
    @property
    def zzl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1
        return vec
    
    @property
    def zwx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.x
        return vec
    
    @property
    def zwy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.y
        return vec
    
    @property
    def zwz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.z
        return vec
    
    @property
    def zww(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.w
        return vec
    
    @property
    def zwo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.w
        vec.z = 0
        return vec
    
    @property
    def zwl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = self.w
        vec.z = 1
        return vec
    
    @property
    def zox(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.x
        return vec
    
    @property
    def zoy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.y
        return vec
    
    @property
    def zoz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.z
        return vec
    
    @property
    def zow(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.w
        return vec
    
    @property
    def zoo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 0
        vec.z = 0
        return vec
    
    @property
    def zol(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 0
        vec.z = 1
        return vec
    
    @property
    def zlx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.x
        return vec
    
    @property
    def zly(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.y
        return vec
    
    @property
    def zlz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.z
        return vec
    
    @property
    def zlw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.w
        return vec
    
    @property
    def zlo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 1
        vec.z = 0
        return vec
    
    @property
    def zll(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.z
        vec.y = 1
        vec.z = 1
        return vec
    
    @property
    def wxx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def wxy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def wxz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def wxw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.w
        return vec
    
    @property
    def wxo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.x
        vec.z = 0
        return vec
    
    @property
    def wxl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.x
        vec.z = 1
        return vec
    
    @property
    def wyx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def wyy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def wyz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def wyw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.w
        return vec
    
    @property
    def wyo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.y
        vec.z = 0
        return vec
    
    @property
    def wyl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.y
        vec.z = 1
        return vec
    
    @property
    def wzx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def wzy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def wzz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def wzw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.w
        return vec
    
    @property
    def wzo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.z
        vec.z = 0
        return vec
    
    @property
    def wzl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.z
        vec.z = 1
        return vec
    
    @property
    def wwx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.x
        return vec
    
    @property
    def wwy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.y
        return vec
    
    @property
    def wwz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.z
        return vec
    
    @property
    def www(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.w
        return vec
    
    @property
    def wwo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.w
        vec.z = 0
        return vec
    
    @property
    def wwl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = self.w
        vec.z = 1
        return vec
    
    @property
    def wox(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.x
        return vec
    
    @property
    def woy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.y
        return vec
    
    @property
    def woz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.z
        return vec
    
    @property
    def wow(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.w
        return vec
    
    @property
    def woo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = 0
        vec.z = 0
        return vec
    
    @property
    def wol(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = 0
        vec.z = 1
        return vec
    
    @property
    def wlx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.x
        return vec
    
    @property
    def wly(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.y
        return vec
    
    @property
    def wlz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.z
        return vec
    
    @property
    def wlw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.w
        return vec
    
    @property
    def wlo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = 1
        vec.z = 0
        return vec
    
    @property
    def wll(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = self.w
        vec.y = 1
        vec.z = 1
        return vec
    
    @property
    def oxx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def oxy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def oxz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def oxw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.w
        return vec
    
    @property
    def oxo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.x
        vec.z = 0
        return vec
    
    @property
    def oxl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.x
        vec.z = 1
        return vec
    
    @property
    def oyx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def oyy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def oyz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def oyw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.w
        return vec
    
    @property
    def oyo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.y
        vec.z = 0
        return vec
    
    @property
    def oyl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.y
        vec.z = 1
        return vec
    
    @property
    def ozx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def ozy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def ozz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def ozw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.w
        return vec
    
    @property
    def ozo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.z
        vec.z = 0
        return vec
    
    @property
    def ozl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.z
        vec.z = 1
        return vec
    
    @property
    def owx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.x
        return vec
    
    @property
    def owy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.y
        return vec
    
    @property
    def owz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.z
        return vec
    
    @property
    def oww(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.w
        return vec
    
    @property
    def owo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.w
        vec.z = 0
        return vec
    
    @property
    def owl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = self.w
        vec.z = 1
        return vec
    
    @property
    def oox(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = 0
        vec.z = self.x
        return vec
    
    @property
    def ooy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = 0
        vec.z = self.y
        return vec
    
    @property
    def ooz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = 0
        vec.z = self.z
        return vec
    
    @property
    def oow(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = 0
        vec.z = self.w
        return vec
    
    @property
    def olx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = 1
        vec.z = self.x
        return vec
    
    @property
    def oly(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = 1
        vec.z = self.y
        return vec
    
    @property
    def olz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = 1
        vec.z = self.z
        return vec
    
    @property
    def olw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 0
        vec.y = 1
        vec.z = self.w
        return vec
    
    @property
    def lxx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.x
        return vec
    
    @property
    def lxy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.y
        return vec
    
    @property
    def lxz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.z
        return vec
    
    @property
    def lxw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.w
        return vec
    
    @property
    def lxo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.x
        vec.z = 0
        return vec
    
    @property
    def lxl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.x
        vec.z = 1
        return vec
    
    @property
    def lyx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.x
        return vec
    
    @property
    def lyy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.y
        return vec
    
    @property
    def lyz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.z
        return vec
    
    @property
    def lyw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.w
        return vec
    
    @property
    def lyo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.y
        vec.z = 0
        return vec
    
    @property
    def lyl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.y
        vec.z = 1
        return vec
    
    @property
    def lzx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.x
        return vec
    
    @property
    def lzy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.y
        return vec
    
    @property
    def lzz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.z
        return vec
    
    @property
    def lzw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.w
        return vec
    
    @property
    def lzo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.z
        vec.z = 0
        return vec
    
    @property
    def lzl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.z
        vec.z = 1
        return vec
    
    @property
    def lwx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.x
        return vec
    
    @property
    def lwy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.y
        return vec
    
    @property
    def lwz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.z
        return vec
    
    @property
    def lww(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.w
        return vec
    
    @property
    def lwo(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.w
        vec.z = 0
        return vec
    
    @property
    def lwl(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = self.w
        vec.z = 1
        return vec
    
    @property
    def lox(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = 0
        vec.z = self.x
        return vec
    
    @property
    def loy(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = 0
        vec.z = self.y
        return vec
    
    @property
    def loz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = 0
        vec.z = self.z
        return vec
    
    @property
    def low(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = 0
        vec.z = self.w
        return vec
    
    @property
    def llx(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = 1
        vec.z = self.x
        return vec
    
    @property
    def lly(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = 1
        vec.z = self.y
        return vec
    
    @property
    def llz(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = 1
        vec.z = self.z
        return vec
    
    @property
    def llw(self):
        cdef Vec3i vec = Vec3i.__new__(Vec3i)
        vec.x = 1
        vec.y = 1
        vec.z = self.w
        return vec
    
    @property
    def xxxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xxxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xxxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xxxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def xxxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def xxxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def xxyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xxyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xxyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xxyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def xxyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def xxyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def xxzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xxzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xxzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xxzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def xxzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def xxzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def xxwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def xxwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def xxwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def xxww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def xxwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def xxwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def xxox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def xxoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def xxoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def xxow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def xxoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def xxol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def xxlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def xxly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def xxlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def xxlw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def xxlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def xxll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.x
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def xyxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xyxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xyxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xyxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def xyxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def xyxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def xyyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xyyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xyyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xyyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def xyyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def xyyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def xyzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xyzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xyzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xyzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @xyzw.setter
    def xyzw(self, Vec4i vec):
        self.x = vec.x
        self.y = vec.y
        self.z = vec.z
        self.w = vec.w
    
    @property
    def xyzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def xyzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def xywx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def xywy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def xywz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @xywz.setter
    def xywz(self, Vec4i vec):
        self.x = vec.x
        self.y = vec.y
        self.w = vec.z
        self.z = vec.w
    
    @property
    def xyww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def xywo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def xywl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def xyox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def xyoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def xyoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def xyow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def xyoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def xyol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def xylx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def xyly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def xylz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def xylw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def xylo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def xyll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.y
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def xzxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xzxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xzxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xzxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def xzxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def xzxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def xzyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xzyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xzyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xzyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @xzyw.setter
    def xzyw(self, Vec4i vec):
        self.x = vec.x
        self.z = vec.y
        self.y = vec.z
        self.w = vec.w
    
    @property
    def xzyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def xzyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def xzzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xzzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xzzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xzzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def xzzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def xzzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def xzwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def xzwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @xzwy.setter
    def xzwy(self, Vec4i vec):
        self.x = vec.x
        self.z = vec.y
        self.w = vec.z
        self.y = vec.w
    
    @property
    def xzwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def xzww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def xzwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def xzwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def xzox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def xzoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def xzoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def xzow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def xzoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def xzol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def xzlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def xzly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def xzlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def xzlw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def xzlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def xzll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.z
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def xwxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xwxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xwxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xwxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def xwxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def xwxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def xwyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xwyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xwyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @xwyz.setter
    def xwyz(self, Vec4i vec):
        self.x = vec.x
        self.w = vec.y
        self.y = vec.z
        self.z = vec.w
    
    @property
    def xwyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def xwyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def xwyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def xwzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xwzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @xwzy.setter
    def xwzy(self, Vec4i vec):
        self.x = vec.x
        self.w = vec.y
        self.z = vec.z
        self.y = vec.w
    
    @property
    def xwzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xwzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def xwzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def xwzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def xwwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def xwwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def xwwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def xwww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def xwwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def xwwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def xwox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def xwoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def xwoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def xwow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def xwoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def xwol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def xwlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def xwly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def xwlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def xwlw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def xwlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def xwll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = self.w
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def xoxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xoxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xoxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xoxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def xoxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def xoxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def xoyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xoyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xoyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xoyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def xoyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def xoyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def xozx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xozy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xozz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xozw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def xozo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def xozl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def xowx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def xowy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def xowz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def xoww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def xowo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def xowl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def xoox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def xooy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def xooz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def xoow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def xooo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def xool(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def xolx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def xoly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def xolz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def xolw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def xolo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def xoll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 0
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def xlxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def xlxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def xlxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def xlxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def xlxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def xlxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def xlyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def xlyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def xlyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def xlyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def xlyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def xlyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def xlzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def xlzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def xlzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def xlzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def xlzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def xlzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def xlwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def xlwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def xlwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def xlww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def xlwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def xlwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def xlox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def xloy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def xloz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def xlow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def xloo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def xlol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def xllx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def xlly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def xllz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def xllw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def xllo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def xlll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.x
        vec.y = 1
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def yxxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yxxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yxxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def yxxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def yxxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def yxxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def yxyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yxyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yxyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def yxyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def yxyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def yxyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def yxzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def yxzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def yxzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def yxzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @yxzw.setter
    def yxzw(self, Vec4i vec):
        self.y = vec.x
        self.x = vec.y
        self.z = vec.z
        self.w = vec.w
    
    @property
    def yxzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def yxzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def yxwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def yxwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def yxwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @yxwz.setter
    def yxwz(self, Vec4i vec):
        self.y = vec.x
        self.x = vec.y
        self.w = vec.z
        self.z = vec.w
    
    @property
    def yxww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def yxwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def yxwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def yxox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def yxoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def yxoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def yxow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def yxoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def yxol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def yxlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def yxly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def yxlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def yxlw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def yxlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def yxll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.x
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def yyxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yyxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yyxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def yyxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def yyxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def yyxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def yyyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yyyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yyyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def yyyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def yyyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def yyyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def yyzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def yyzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def yyzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def yyzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def yyzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def yyzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def yywx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def yywy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def yywz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def yyww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def yywo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def yywl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def yyox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def yyoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def yyoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def yyow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def yyoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def yyol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def yylx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def yyly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def yylz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def yylw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def yylo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def yyll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.y
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def yzxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yzxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yzxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def yzxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @yzxw.setter
    def yzxw(self, Vec4i vec):
        self.y = vec.x
        self.z = vec.y
        self.x = vec.z
        self.w = vec.w
    
    @property
    def yzxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def yzxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def yzyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yzyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yzyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def yzyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def yzyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def yzyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def yzzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def yzzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def yzzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def yzzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def yzzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def yzzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def yzwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @yzwx.setter
    def yzwx(self, Vec4i vec):
        self.y = vec.x
        self.z = vec.y
        self.w = vec.z
        self.x = vec.w
    
    @property
    def yzwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def yzwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def yzww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def yzwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def yzwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def yzox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def yzoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def yzoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def yzow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def yzoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def yzol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def yzlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def yzly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def yzlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def yzlw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def yzlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def yzll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.z
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def ywxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def ywxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def ywxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @ywxz.setter
    def ywxz(self, Vec4i vec):
        self.y = vec.x
        self.w = vec.y
        self.x = vec.z
        self.z = vec.w
    
    @property
    def ywxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def ywxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def ywxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def ywyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def ywyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def ywyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def ywyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def ywyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def ywyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def ywzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @ywzx.setter
    def ywzx(self, Vec4i vec):
        self.y = vec.x
        self.w = vec.y
        self.z = vec.z
        self.x = vec.w
    
    @property
    def ywzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def ywzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def ywzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def ywzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def ywzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def ywwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def ywwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def ywwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def ywww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def ywwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def ywwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def ywox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def ywoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def ywoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def ywow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def ywoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def ywol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def ywlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def ywly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def ywlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def ywlw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def ywlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def ywll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = self.w
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def yoxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def yoxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def yoxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def yoxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def yoxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def yoxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def yoyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def yoyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def yoyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def yoyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def yoyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def yoyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def yozx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def yozy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def yozz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def yozw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def yozo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def yozl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def yowx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def yowy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def yowz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def yoww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def yowo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def yowl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def yoox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def yooy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def yooz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def yoow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def yooo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def yool(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def yolx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def yoly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def yolz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def yolw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def yolo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def yoll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 0
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def ylxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def ylxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def ylxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def ylxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def ylxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def ylxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def ylyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def ylyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def ylyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def ylyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def ylyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def ylyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def ylzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def ylzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def ylzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def ylzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def ylzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def ylzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def ylwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def ylwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def ylwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def ylww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def ylwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def ylwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def ylox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def yloy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def yloz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def ylow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def yloo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def ylol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def yllx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def ylly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def yllz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def yllw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def yllo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def ylll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.y
        vec.y = 1
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def zxxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zxxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zxxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zxxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def zxxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def zxxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def zxyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zxyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zxyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zxyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @zxyw.setter
    def zxyw(self, Vec4i vec):
        self.z = vec.x
        self.x = vec.y
        self.y = vec.z
        self.w = vec.w
    
    @property
    def zxyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def zxyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def zxzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zxzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zxzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zxzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def zxzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def zxzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def zxwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def zxwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @zxwy.setter
    def zxwy(self, Vec4i vec):
        self.z = vec.x
        self.x = vec.y
        self.w = vec.z
        self.y = vec.w
    
    @property
    def zxwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def zxww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def zxwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def zxwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def zxox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def zxoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def zxoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def zxow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def zxoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def zxol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def zxlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def zxly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def zxlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def zxlw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def zxlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def zxll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.x
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def zyxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zyxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zyxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zyxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @zyxw.setter
    def zyxw(self, Vec4i vec):
        self.z = vec.x
        self.y = vec.y
        self.x = vec.z
        self.w = vec.w
    
    @property
    def zyxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def zyxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def zyyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zyyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zyyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zyyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def zyyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def zyyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def zyzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zyzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zyzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zyzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def zyzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def zyzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def zywx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @zywx.setter
    def zywx(self, Vec4i vec):
        self.z = vec.x
        self.y = vec.y
        self.w = vec.z
        self.x = vec.w
    
    @property
    def zywy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def zywz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def zyww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def zywo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def zywl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def zyox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def zyoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def zyoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def zyow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def zyoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def zyol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def zylx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def zyly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def zylz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def zylw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def zylo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def zyll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.y
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def zzxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zzxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zzxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zzxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def zzxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def zzxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def zzyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zzyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zzyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zzyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def zzyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def zzyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def zzzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zzzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zzzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zzzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def zzzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def zzzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def zzwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def zzwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def zzwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def zzww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def zzwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def zzwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def zzox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def zzoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def zzoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def zzow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def zzoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def zzol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def zzlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def zzly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def zzlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def zzlw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def zzlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def zzll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.z
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def zwxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zwxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @zwxy.setter
    def zwxy(self, Vec4i vec):
        self.z = vec.x
        self.w = vec.y
        self.x = vec.z
        self.y = vec.w
    
    @property
    def zwxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zwxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def zwxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def zwxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def zwyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @zwyx.setter
    def zwyx(self, Vec4i vec):
        self.z = vec.x
        self.w = vec.y
        self.y = vec.z
        self.x = vec.w
    
    @property
    def zwyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zwyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zwyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def zwyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def zwyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def zwzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zwzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zwzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zwzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def zwzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def zwzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def zwwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def zwwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def zwwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def zwww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def zwwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def zwwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def zwox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def zwoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def zwoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def zwow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def zwoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def zwol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def zwlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def zwly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def zwlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def zwlw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def zwlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def zwll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = self.w
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def zoxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zoxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zoxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zoxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def zoxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def zoxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def zoyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zoyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zoyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zoyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def zoyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def zoyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def zozx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zozy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zozz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zozw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def zozo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def zozl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def zowx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def zowy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def zowz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def zoww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def zowo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def zowl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def zoox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def zooy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def zooz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def zoow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def zooo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def zool(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def zolx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def zoly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def zolz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def zolw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def zolo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def zoll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 0
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def zlxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def zlxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def zlxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def zlxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def zlxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def zlxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def zlyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def zlyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def zlyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def zlyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def zlyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def zlyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def zlzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def zlzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def zlzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def zlzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def zlzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def zlzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def zlwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def zlwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def zlwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def zlww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def zlwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def zlwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def zlox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def zloy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def zloz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def zlow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def zloo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def zlol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def zllx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def zlly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def zllz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def zllw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def zllo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def zlll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.z
        vec.y = 1
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def wxxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def wxxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def wxxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def wxxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def wxxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def wxxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def wxyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def wxyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def wxyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @wxyz.setter
    def wxyz(self, Vec4i vec):
        self.w = vec.x
        self.x = vec.y
        self.y = vec.z
        self.z = vec.w
    
    @property
    def wxyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def wxyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def wxyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def wxzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def wxzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @wxzy.setter
    def wxzy(self, Vec4i vec):
        self.w = vec.x
        self.x = vec.y
        self.z = vec.z
        self.y = vec.w
    
    @property
    def wxzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def wxzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def wxzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def wxzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def wxwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def wxwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def wxwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def wxww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def wxwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def wxwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def wxox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def wxoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def wxoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def wxow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def wxoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def wxol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def wxlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def wxly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def wxlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def wxlw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def wxlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def wxll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.x
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def wyxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def wyxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def wyxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @wyxz.setter
    def wyxz(self, Vec4i vec):
        self.w = vec.x
        self.y = vec.y
        self.x = vec.z
        self.z = vec.w
    
    @property
    def wyxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def wyxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def wyxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def wyyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def wyyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def wyyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def wyyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def wyyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def wyyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def wyzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @wyzx.setter
    def wyzx(self, Vec4i vec):
        self.w = vec.x
        self.y = vec.y
        self.z = vec.z
        self.x = vec.w
    
    @property
    def wyzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def wyzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def wyzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def wyzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def wyzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def wywx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def wywy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def wywz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def wyww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def wywo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def wywl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def wyox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def wyoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def wyoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def wyow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def wyoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def wyol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def wylx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def wyly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def wylz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def wylw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def wylo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def wyll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.y
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def wzxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def wzxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @wzxy.setter
    def wzxy(self, Vec4i vec):
        self.w = vec.x
        self.z = vec.y
        self.x = vec.z
        self.y = vec.w
    
    @property
    def wzxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def wzxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def wzxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def wzxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def wzyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @wzyx.setter
    def wzyx(self, Vec4i vec):
        self.w = vec.x
        self.z = vec.y
        self.y = vec.z
        self.x = vec.w
    
    @property
    def wzyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def wzyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def wzyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def wzyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def wzyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def wzzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def wzzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def wzzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def wzzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def wzzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def wzzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def wzwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def wzwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def wzwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def wzww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def wzwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def wzwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def wzox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def wzoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def wzoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def wzow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def wzoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def wzol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def wzlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def wzly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def wzlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def wzlw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def wzlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def wzll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.z
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def wwxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def wwxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def wwxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def wwxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def wwxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def wwxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def wwyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def wwyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def wwyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def wwyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def wwyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def wwyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def wwzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def wwzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def wwzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def wwzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def wwzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def wwzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def wwwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def wwwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def wwwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def wwww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def wwwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def wwwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def wwox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def wwoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def wwoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def wwow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def wwoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def wwol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def wwlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def wwly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def wwlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def wwlw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def wwlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def wwll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = self.w
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def woxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def woxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def woxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def woxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def woxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def woxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def woyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def woyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def woyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def woyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def woyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def woyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def wozx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def wozy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def wozz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def wozw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def wozo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def wozl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def wowx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def wowy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def wowz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def woww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def wowo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def wowl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def woox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def wooy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def wooz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def woow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def wooo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def wool(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def wolx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def woly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def wolz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def wolw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def wolo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def woll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 0
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def wlxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def wlxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def wlxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def wlxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def wlxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def wlxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def wlyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def wlyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def wlyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def wlyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def wlyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def wlyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def wlzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def wlzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def wlzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def wlzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def wlzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def wlzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def wlwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def wlwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def wlwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def wlww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def wlwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def wlwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def wlox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def wloy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def wloz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def wlow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def wloo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def wlol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def wllx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def wlly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def wllz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def wllw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def wllo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def wlll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = self.w
        vec.y = 1
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def oxxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def oxxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def oxxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def oxxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def oxxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def oxxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def oxyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def oxyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def oxyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def oxyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def oxyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def oxyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def oxzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def oxzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def oxzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def oxzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def oxzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def oxzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def oxwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def oxwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def oxwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def oxww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def oxwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def oxwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def oxox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def oxoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def oxoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def oxow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def oxoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def oxol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def oxlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def oxly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def oxlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def oxlw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def oxlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def oxll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.x
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def oyxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def oyxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def oyxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def oyxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def oyxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def oyxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def oyyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def oyyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def oyyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def oyyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def oyyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def oyyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def oyzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def oyzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def oyzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def oyzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def oyzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def oyzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def oywx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def oywy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def oywz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def oyww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def oywo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def oywl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def oyox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def oyoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def oyoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def oyow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def oyoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def oyol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def oylx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def oyly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def oylz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def oylw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def oylo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def oyll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.y
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def ozxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def ozxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def ozxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def ozxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def ozxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def ozxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def ozyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def ozyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def ozyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def ozyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def ozyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def ozyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def ozzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def ozzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def ozzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def ozzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def ozzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def ozzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def ozwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def ozwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def ozwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def ozww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def ozwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def ozwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def ozox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def ozoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def ozoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def ozow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def ozoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def ozol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def ozlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def ozly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def ozlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def ozlw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def ozlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def ozll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.z
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def owxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def owxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def owxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def owxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def owxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def owxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def owyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def owyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def owyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def owyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def owyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def owyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def owzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def owzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def owzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def owzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def owzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def owzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def owwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def owwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def owwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def owww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def owwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def owwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def owox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def owoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def owoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def owow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def owoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def owol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def owlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def owly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def owlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def owlw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def owlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def owll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = self.w
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def ooxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def ooxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def ooxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def ooxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def ooxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def ooxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def ooyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def ooyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def ooyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def ooyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def ooyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def ooyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def oozx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def oozy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def oozz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def oozw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def oozo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def oozl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def oowx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def oowy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def oowz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def ooww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def oowo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def oowl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def ooox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def oooy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def oooz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def ooow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def oolx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def ooly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def oolz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def oolw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 0
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def olxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def olxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def olxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def olxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def olxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def olxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def olyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def olyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def olyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def olyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def olyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def olyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def olzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def olzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def olzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def olzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def olzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def olzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def olwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def olwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def olwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def olww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def olwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def olwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def olox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def oloy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def oloz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def olow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def ollx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def olly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def ollz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def ollw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 0
        vec.y = 1
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def lxxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def lxxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def lxxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def lxxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def lxxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def lxxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def lxyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def lxyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def lxyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def lxyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def lxyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def lxyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def lxzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def lxzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def lxzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def lxzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def lxzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def lxzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def lxwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def lxwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def lxwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def lxww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def lxwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def lxwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def lxox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def lxoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def lxoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def lxow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def lxoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def lxol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def lxlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def lxly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def lxlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def lxlw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def lxlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def lxll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.x
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def lyxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def lyxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def lyxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def lyxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def lyxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def lyxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def lyyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def lyyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def lyyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def lyyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def lyyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def lyyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def lyzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def lyzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def lyzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def lyzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def lyzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def lyzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def lywx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def lywy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def lywz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def lyww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def lywo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def lywl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def lyox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def lyoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def lyoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def lyow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def lyoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def lyol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def lylx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def lyly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def lylz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def lylw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def lylo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def lyll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.y
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def lzxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def lzxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def lzxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def lzxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def lzxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def lzxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def lzyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def lzyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def lzyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def lzyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def lzyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def lzyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def lzzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def lzzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def lzzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def lzzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def lzzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def lzzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def lzwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def lzwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def lzwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def lzww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def lzwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def lzwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def lzox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def lzoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def lzoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def lzow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def lzoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def lzol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def lzlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def lzly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def lzlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def lzlw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def lzlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def lzll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.z
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def lwxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def lwxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def lwxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def lwxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def lwxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def lwxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def lwyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def lwyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def lwyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def lwyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def lwyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def lwyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def lwzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def lwzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def lwzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def lwzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def lwzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def lwzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def lwwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def lwwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def lwwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def lwww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def lwwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def lwwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def lwox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def lwoy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def lwoz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def lwow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def lwoo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = 0
        vec.w = 0
        return vec
    
    @property
    def lwol(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = 0
        vec.w = 1
        return vec
    
    @property
    def lwlx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def lwly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def lwlz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def lwlw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def lwlo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = 1
        vec.w = 0
        return vec
    
    @property
    def lwll(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = self.w
        vec.z = 1
        vec.w = 1
        return vec
    
    @property
    def loxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def loxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def loxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def loxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def loxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def loxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def loyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def loyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def loyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def loyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def loyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def loyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def lozx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def lozy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def lozz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def lozw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def lozo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def lozl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def lowx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def lowy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def lowz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def loww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def lowo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def lowl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def loox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def looy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def looz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def loow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def lolx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def loly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def lolz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def lolw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 0
        vec.z = 1
        vec.w = self.w
        return vec
    
    @property
    def llxx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.x
        vec.w = self.x
        return vec
    
    @property
    def llxy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.x
        vec.w = self.y
        return vec
    
    @property
    def llxz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.x
        vec.w = self.z
        return vec
    
    @property
    def llxw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.x
        vec.w = self.w
        return vec
    
    @property
    def llxo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.x
        vec.w = 0
        return vec
    
    @property
    def llxl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.x
        vec.w = 1
        return vec
    
    @property
    def llyx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.y
        vec.w = self.x
        return vec
    
    @property
    def llyy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.y
        vec.w = self.y
        return vec
    
    @property
    def llyz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.y
        vec.w = self.z
        return vec
    
    @property
    def llyw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.y
        vec.w = self.w
        return vec
    
    @property
    def llyo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.y
        vec.w = 0
        return vec
    
    @property
    def llyl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.y
        vec.w = 1
        return vec
    
    @property
    def llzx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.z
        vec.w = self.x
        return vec
    
    @property
    def llzy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.z
        vec.w = self.y
        return vec
    
    @property
    def llzz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.z
        vec.w = self.z
        return vec
    
    @property
    def llzw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.z
        vec.w = self.w
        return vec
    
    @property
    def llzo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.z
        vec.w = 0
        return vec
    
    @property
    def llzl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.z
        vec.w = 1
        return vec
    
    @property
    def llwx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.w
        vec.w = self.x
        return vec
    
    @property
    def llwy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.w
        vec.w = self.y
        return vec
    
    @property
    def llwz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.w
        vec.w = self.z
        return vec
    
    @property
    def llww(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.w
        vec.w = self.w
        return vec
    
    @property
    def llwo(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.w
        vec.w = 0
        return vec
    
    @property
    def llwl(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = self.w
        vec.w = 1
        return vec
    
    @property
    def llox(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = 0
        vec.w = self.x
        return vec
    
    @property
    def lloy(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = 0
        vec.w = self.y
        return vec
    
    @property
    def lloz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = 0
        vec.w = self.z
        return vec
    
    @property
    def llow(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = 0
        vec.w = self.w
        return vec
    
    @property
    def lllx(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = 1
        vec.w = self.x
        return vec
    
    @property
    def llly(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = 1
        vec.w = self.y
        return vec
    
    @property
    def lllz(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = 1
        vec.w = self.z
        return vec
    
    @property
    def lllw(self):
        cdef Vec4i vec = Vec4i.__new__(Vec4i)
        vec.x = 1
        vec.y = 1
        vec.z = 1
        vec.w = self.w
        return vec


@cython.no_gc
@cython.final
@cython.freelist(8)
cdef class _Vec4iiterator:
    cdef public int x, y, z, w
    cdef short index


    def __next__(self):
        if self.index == 0:
            self.index += 1
            return self.x
        elif self.index == 1:
            self.index += 1
            return self.y
        elif self.index == 2:
            self.index += 1
            return self.z
        elif self.index == 3:
            self.index += 1
            return self.w
        raise StopIteration

    def __iter__(self):
        return self

    def __length_hint__(self):
        return 4

